## flexiblas-3.4.1.tar.gz

=== CMakeLists.txt ===
INCLUDE(libcscutils/CMakeModules/CheckPolicy.cmake)
CheckPolicy(CMP0048 NEW)

PROJECT(FlexiBLAS LANGUAGES C Fortran VERSION 3.4.1)
cmake_minimum_required(VERSION 3.5.0)
cmake_policy(SET CMP0054 NEW)

#
# FlexiBLAS version setup
#
SET(FLEXIBLAS_VERSION "${FlexiBLAS_VERSION}")
SET(FLEXIBLAS_VERSION_MAJOR  ${FlexiBLAS_VERSION_MAJOR})
SET(FLEXIBLAS_VERSION_MINOR  ${FlexiBLAS_VERSION_MINOR})
SET(FLEXIBLAS_VERSION_PATCH  ${FlexiBLAS_VERSION_PATCH})
IF ( NOT FLEXIBLAS_VERSION_PATCH )
    SET(FLEXIBLAS_VERSION_PATCH "0")
ENDIF()
SET(FLEXIBLAS_YEARS "2013-2024")
MESSAGE(STATUS "Configuring FlexiBLAS ${FlexiBLAS_VERSION_MAJOR}.${FlexiBLAS_VERSION_MINOR}.${FlexiBLAS_VERSION_PATCH}")


SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/libcscutils/CMakeModules ${PROJECT_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)

INCLUDE (CheckFeatureNeeded)
INCLUDE (PreventInSourceBuilds)
INCLUDE (PreventInBuildInstalls)
INCLUDE (CMakeHelpers)

#
# Options
#
OPTION(TESTS "Enable Tests" ON)
OPTION(CBLAS "Enable CBLAS Interface" ON )
OPTION(INTEGER8 "Use 8 Byte Integer" OFF)
OPTION(BUILD_SHARED_LIBS "Enable Shared Library" ON)
OPTION(LAPACK "Enable LAPACK Support" ON)
OPTION(DEV "Development Build" OFF)
OPTION(MKL_BUILDER "Build MKL support with Intel MKLs Custom library builder" OFF)
OPTION(EXAMPLES "Build Examples" ON)
OPTION(BLAS_AUTO_DETECT "Enabled the BLAS auto detection during configuration" ON)
OPTION(LINK_OPENMP "Link OpenMP to FlexiBLAS" OFF)

IF (NOT DEFINED FLEXIBLAS_DEFAULT_BLAS)
    SET(FLEXIBLAS_DEFAULT_BLAS "NETLIB")
ELSE()
    STRING (TOUPPER "${FLEXIBLAS_DEFAULT_BLAS}" FLEXIBLAS_DEFAULT_BLAS)
ENDIF()

#
# build type
#
IF( NOT CMAKE_BUILD_TYPE )
	SET( CMAKE_BUILD_TYPE "Release" )
ENDIF( NOT CMAKE_BUILD_TYPE )

IF ( CMAKE_BUILD_TYPE STREQUAL "Debug" )
	SET ( DEBUG "ON" )
ENDIF ( CMAKE_BUILD_TYPE STREQUAL "Debug" )

#
# Paths
#
INCLUDE(GNUInstallDirs)

IF(DEFINED SYSCONFDIR)
 SET(CMAKE_INSTALL_FULL_SYSCONFDIR ${SYSCONFDIR})
ENDIF()

MESSAGE(STATUS "SYSCONFDIR: ${CMAKE_INSTALL_FULL_SYSCONFDIR}")
MESSAGE(STATUS "LIBDIR:     ${CMAKE_INSTALL_FULL_LIBDIR}")
MESSAGE(STATUS "BINDIR:     ${CMAKE_INSTALL_FULL_BINDIR}")
MESSAGE(STATUS "INCLUDEDIR: ${CMAKE_INSTALL_FULL_INCLUDEDIR}")
MESSAGE(STATUS "MANDIR:     ${CMAKE_INSTALL_FULL_MANDIR}")
MESSAGE(STATUS "Compiler_ID: ${CMAKE_C_COMPILER_ID}")
MESSAGE(STATUS "FCompiler_ID: ${CMAKE_Fortran_COMPILER_ID}")

#
# Compiler Settings
#
SET(CMAKE_POSITION_INDEPENDENT_CODE ON)
INCLUDE(CCompilerSettings)
INCLUDE(FortranCompilerSettings)


# Check C Compiler Version
IF ( CMAKE_C_COMPILER_ID STREQUAL "GNU" AND CMAKE_C_COMPILER_VERSION VERSION_LESS "5.0.0" )
	MESSAGE_COLOR(STATUS COLOR_BOLD_RED "Your gcc is older than version 5.0.0. LAPACK will be loaded using DEEPBIND")
	ADD_DEFINITIONS(-DLAPACK_DEEP_BIND)
ENDIF()

INCLUDE(ccache)




#SET(BUILD_SHARED_LIBS ON)
SET(LIBS m)
INCLUDE(CheckCCompilerFlag)
INCLUDE(CheckFortranCompilerFlag)

INCLUDE(EnablePedanticC)
INCLUDE(EnableStrictPrototypesC)
INCLUDE(EnableCastQual)


IF ( ${CMAKE_C_COMPILER_ID} STREQUAL "GNU")
    check_c_compiler_flag("-fstack-protector-strong" C_STACK_PROTECTOR)
    check_c_compiler_flag("-fstack-clash-protection" C_STACK_CLASH)
    check_fortran_compiler_flag("-fstack-protector-strong" FC_STACK_PROTECTOR)
    check_fortran_compiler_flag("-fstack-clash-protection" FC_STACK_CLASH)


    SET( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
    IF(C_STACK_PROTECTOR)
        SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-strong")
    ENDIF()
    IF (C_STACK_CLASH)
        SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-clash-protection")
    ENDIF()
    IF(FC_STACK_PROTECTOR)
        SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fstack-protector-strong")
    ENDIF()
    IF (FC_STACK_CLASH)
        SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fstack-clash-protection")
    ENDIF()
ENDIF()

IF (DEBUG STREQUAL ON)
	SET( CMAKE_BUILD_TYPE "Debug" )
	SET ( DEBUG TRUE)
	SET( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DDEBUG")
ENDIF (DEBUG STREQUAL ON )

IF (LINK_OPENMP)
    FIND_PACKAGE(OpenMP REQUIRED)
	if(NOT TARGET OpenMP::OpenMP_C)
		find_package(Threads REQUIRED)
		add_library(OpenMP::OpenMP_C IMPORTED INTERFACE)
		set_property(TARGET OpenMP::OpenMP_C
			PROPERTY INTERFACE_COMPILE_OPTIONS ${OpenMP_C_FLAGS})
		# Only works if the same flag is passed to the linker; use CMake 3.9+ otherwise (Intel, AppleClang)
		set_property(TARGET OpenMP::OpenMP_C
			PROPERTY INTERFACE_LINK_LIBRARIES ${OpenMP_C_FLAGS} Threads::Threads)
	endif()
ENDIF()





IF (NOT DEFINED ABI)
	IF ( ${CMAKE_Fortran_COMPILER_ID} STREQUAL "Intel")
		SET(ABI "Intel" CACHE STRING "ABI of the Fortran Interface")
	ELSEIF ( ${CMAKE_Fortran_COMPILER_ID} STREQUAL "PGI" )
		SET(ABI "Intel" CACHE STRING "ABI of the Fortran Interface")
	ELSEIF ( ${CMAKE_Fortran_COMPILER_ID} STREQUAL "XL" )
		SET(ABI "XL" CACHE STREQUAL "ABI of the Fortran Interface")
	ELSE()
		SET(USE_INTERFACE_INTEL FALSE)
		SET(ABI "GNU" CACHE STRING "ABI of the Fortran Interface")
	ENDIF()
ELSE()
	IF (NOT ( ABI STREQUAL "GNU" OR ABI STREQUAL "Intel" OR ABI STREQUAL "XL"))
		MESSAGE(FATAL_ERROR "ABI must be GNU or Intel")
	ENDIF()
ENDIF()

IF ( ABI STREQUAL "Intel")
	SET(FLEXIBLAS_ABI_INTEL TRUE)
	SET(USE_INTERFACE_INTEL TRUE)
ELSEIF ( ABI STREQUAL "XL" )
	SET(FLEXIBLAS_ABI_IBM TRUE)
ELSE ()
	SET (FLEXIBLAS_ABI_GNU TRUE)
	SET(USE_INTERFACE_INTEL FALSE)
ENDIF()

# Name Mangling
include(FortranCInterface)
FortranCInterface_HEADER(${PROJECT_BINARY_DIR}/include/flexiblas_fortran_mangle.h
	                 MACRO_NAMESPACE "FC_"
			 SYMBOL_NAMESPACE "FC_")
FortranCInterface_VERIFY()

include(CheckThreadLocal)

IF (DEFINED FALLBACK)
	SET (FALLBACK_NAME "${FALLBACK}")
ELSE()
	SET (FALLBACK_NAME FALSE)
ENDIF()

SET ( INCLUDE_DIR ${INCLUDE_DIR} ${CMAKE_BINARY_DIR}/include ${CMAKE_SOURCE_DIR}/include ${CMAKE_BINARY_DIR} )




LIST(REMOVE_DUPLICATES INCLUDE_DIR)
IF (APPLE)
	SET ( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_FILE_OFFSET_BITS=64 ")
	SET ( CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -rdynamic -Wl,-export_dynamic")
ELSE()
	IF (WIN32)
		SET ( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_FILE_OFFSET_BITS=64 -Wall")
	ELSE ()
		SET ( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_FILE_OFFSET_BITS=64")
		IF  ( CMAKE_Fortran_COMPILER_ID STREQUAL "Intel" OR CMAKE_Fortran_COMPILER_ID STREQUAL "GNU")
            set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -rdynamic -Wl,--export-dynamic")
		ENDIF()
		# SET ( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_FILE_OFFSET_BITS=64 ")

	ENDIF()
ENDIF()
SET ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_FILE_OFFSET_BITS=64 ")

SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)


#
# Check Some files
#
INCLUDE (CheckIncludeFiles)
IF (WIN32)
	MESSAGE(STATUS "Building Windows Version" )
	IF (MINGW)
		MESSAGE(STATUS "Using MingW Compiler")
	ENDIF()
	SET(DL_LIB "")
ELSE()
	# CHECK_INCLUDE_FILES (stdatomic.h HAVE_STDATOMIC_H)
	CHECK_INCLUDE_FILES (dlfcn.h	 HAVE_DLFCN_H)
	CHECK_INCLUDE_FILES (sys/sysmacro.h HAVE_SYSMACRO_H)
	CHECK_INCLUDE_FILES (sys/stat.h     HAVE_SYS_STAT_H)
	INCLUDE (CheckSymbolExists)
	CHECK_SYMBOL_EXISTS(RTLD_GLOBAL   "dlfcn.h" HAVE_RTLD_GLOBAL)
	CHECK_SYMBOL_EXISTS(RTLD_DEEPBIND "dlfcn.h" HAVE_RTLD_DEEPBIND)
	CHECK_SYMBOL_EXISTS(RTLD_NOW	  "dlfcn.h" HAVE_RTLD_NOW)
    CHECK_SYMBOL_EXISTS(RTLD_NODELETE "dlfcn.h" HAVE_RTLD_NODELETE)

	INCLUDE (CheckFunctionExists)
	CHECK_FUNCTION_EXISTS(dlopen DLOPEN_C)
	SET(__CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
	SET(CMAKE_REQUIRED_LIBRARIES dl)
	CHECK_FUNCTION_EXISTS(dlopen DLOPEN_DL)
	SET(CMAKE_REQUIRED_LIBRARIES ${__CMAKE_REQUIRED_LIBRARIES})

	IF (DLOPEN_DL)
	 SET(LIBS ${LIBS} dl)
	 SET(DL_LIB dl)
	ENDIF()
	IF (NOT ( DLOPEN_DL OR DLOPEN_C ) )
	 MESSAGE(ERROR "No dlopen function found")
	ENDIF()

	IF ( NOT HAVE_DLFCN_H )
		MESSAGE(FATAL_ERROR "dlfcn.h not found, aborting")
	ENDIF()

    IF ( NOT HAVE_RTLD_NODELETE )
        MESSAGE(WARNING "RTLD_NODELETE not found in your C library. Consider setting -DLINK_OPENMP=ON")
    ENDIF()
ENDIF()

INCLUDE(CheckAttributeExists)
Check_Attribute_Exists( constructor HAVE_ATTR_CONSTRUCTOR)
Check_Attribute_Exists( "alias(\"foo\")" HAVE_ATTR_ALIAS)
Check_Attribute_Exists( "visibility(\"hidden\")" HAVE_ATTR_HIDDEN)
Check_Attribute_Exists( "visibility(\"default\")" HAVE_ATTR_DEFAULT)
Check_Attribute_Exists( unused HAVE_ATTR_UNUSED )
SET(EXTRA_BLAS "")


### libcscutils
SET(CSCUTILS_FEATURES "inifile;ds")
SET(CSCUTILS_OBJECT TRUE)
add_subdirectory(libcscutils)
SET(LIBS ${LIBS})
SET(INCLUDE_DIR ${INCLUDE_DIR} "${PROJECT_SOURCE_DIR}/libcscutils/include" "${PROJECT_BINARY_DIR}/libcscutils/include")

IF (CBLAS STREQUAL ON)
	ADD_DEFINITIONS(-DFLEXIBLAS_CBLAS)
ENDIF()


### Setup Integer8 option
IF ( INTEGER8 STREQUAL ON )
	ADD_DEFINITIONS(-DINTEGER8)
	SET(FLEXIBLAS_INTEGER8 TRUE)
	SET(FLEXIBLAS_INCLUDE_PREFIX "flexiblas64")
	SET(FLEXIBLAS_LIBRARY_DIR "flexiblas64")
	SET(FLEXIBLAS_PKG_CONFIG "flexiblas64.pc")
    SET(FLEXIBLAS_API_PKG_CONFIG "flexiblas64_api.pc")
    SET(FLEXIBLAS_LIBRARY_NAME "flexiblas64")
    set(flexiblasname flexiblas64)
	SET (FLEXIBLASRC flexiblas64rc)
	SET (FLEXIBLAS_RC "flexiblas64rc")
    SET (FLEXIBLAS_RC_DIR "flexiblas64rc.d")
    SET (FLEXIBLAS_PREFIX "flexiblas64")

    IF ( ${CMAKE_C_COMPILER_ID} STREQUAL "GNU")
		MESSAGE(STATUS "Setting GNU Compiler Flags")
		SET(I8_FLAGS "-fdefault-integer-8 ")
	ELSEIF (${CMAKE_C_COMPILER_ID} STREQUAL "Intel" )
		SET ( I8_FLAGS "-i8 ")
	ELSEIF (${CMAKE_C_COMPILER_ID} STREQUAL "PGI" )
		SET ( I8_FLAGS "-i8 ")
	ENDIF()
	SET (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${I8_FLAGS}")
    SET (FLEXIBLAS_FC_I8FLAG "${I8_FLAGS}")
ELSE()
	SET(FLEXIBLAS_INTEGER8 FALSE)
	SET(FLEXIBLAS_INCLUDE_PREFIX "flexiblas")
	SET(FLEXIBLAS_PKG_CONFIG "flexiblas.pc")
    SET(FLEXIBLAS_API_PKG_CONFIG "flexiblas_api.pc")
	SET(FLEXIBLAS_LIBRARY_DIR "flexiblas")
    SET(FLEXIBLAS_LIBRARY_NAME "flexiblas")
    set(flexiblasname flexiblas)
	SET (FLEXIBLASRC flexiblasrc)
    SET (FLEXIBLAS_RC "flexiblasrc")
    SET (FLEXIBLAS_RC_DIR "flexiblasrc.d")
    SET (FLEXIBLAS_PREFIX "flexiblas")
ENDIF (INTEGER8 STREQUAL ON)
FILE(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/${FLEXIBLAS_RC_DIR}")

IF (DEV STREQUAL ON)
	SET ( FLEXIBLAS_DEFAULT_LIB_PATH "${CMAKE_BINARY_DIR}/lib:${CMAKE_BINARY_DIR}/contributed/netlib-blas:${CMAKE_BINARY_DIR}/contributed/:${CMAKE_BINARY_DIR}/src:")
    SET ( CMAKE_INSTALL_FULL_SYSCONFDIR "${CMAKE_BINARY_DIR}")
ELSE()
    SET ( FLEXIBLAS_DEFAULT_LIB_PATH "${CMAKE_INSTALL_FULL_LIBDIR}/${flexiblasname}/")
ENDIF()



# Check for Serveral Functions
CHECK_FEATURE_NEEDED(strdup string.h HAVE_STRDUP STRDUP_FEATURE)
IF( HAVE_STRDUP )
	ADD_DEFINITIONS("${STRDUP_FEATURE}")
ELSE ()
	MESSAGE(FATAL_ERROR "strdup not found")
ENDIF()
CHECK_FEATURE_NEEDED(realpath stdlib.h HAVE_REALPATH REALPATH_FEATURE)
IF( HAVE_REALPATH  )
	ADD_DEFINITIONS("${REALPATH_FEATURE}")
ELSE ()
	MESSAGE(FATAL_ERROR "realpath not found")
ENDIF()

### Add Source

INCLUDE(lapack)

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/src)


CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/config.h.in ${CMAKE_BINARY_DIR}/include/flexiblas_config.h)


add_subdirectory(src)

IF(EXAMPLES STREQUAL "ON")
add_subdirectory(examples)
ENDIF()
IF(EXISTS tools/lapack_checks)
add_subdirectory(tools/lapack_checks)
ENDIF()

### Install
INSTALL(FILES   ${CMAKE_CURRENT_BINARY_DIR}/${FLEXIBLASRC} DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR} PERMISSIONS OWNER_WRITE  OWNER_READ  GROUP_READ WORLD_READ )
INSTALL(FILES   ${CMAKE_SOURCE_DIR}/include/blas_gnu.h
		${CMAKE_SOURCE_DIR}/include/blas_intel.h
		${CMAKE_BINARY_DIR}/include/flexiblas_config.h
        ${CMAKE_BINARY_DIR}/include/flexiblas_api.h
		${CMAKE_BINARY_DIR}/include/flexiblas_fortran_mangle.h
		DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR}/${FLEXIBLAS_INCLUDE_PREFIX}/)
IF(LAPACK STREQUAL ON)
	INSTALL(FILES   ${CMAKE_BINARY_DIR}/include/lapack.h
		${CMAKE_BINARY_DIR}/include/flexiblas_real_lapack.h

=== examples/CMakeLists.txt ===
FIND_PACKAGE(OpenMP)
SET(SRC)
IF ( OpenMP_FOUND)
	SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
	MESSAGE(STATUS "Enable Multithread Demo")
	SET( SRC  demo_multithread)
ENDIF()


SET (SRC ${SRC}  	demo_1
	demo_2
	demo_api
	demo_set_threads
	benchmark
	test_zdotc_gnu
	test_zdotc_intel
	demo_xerbla
	demo_axpby
	demo_omatcopy
	demo_imatcopy
	)

IF ( LAPACK )
	SET (SRC ${SRC} benchmark_dgetrf)
ENDIF ()

IF (CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
    SET (SRC ${SRC} benchmark_overhead_quickreturn)
ENDIF()

IF ( CMAKE_C_COMPILER_ID STREQUAL "GNU")
	SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-parameter")
ENDIF()


INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/include ${CMAKE_SOURCE_DIR}/libcscutils/include ${PROJECT_BINARY_DIR}/include/ ${PROJECT_BINARY_DIR}/libcscutils/include)
foreach (srcfile ${SRC})
	add_executable (${srcfile} ${srcfile}.c)
	target_link_libraries (${srcfile} ${LIBS} flexiblas cscutils ${LIBS})
endforeach (srcfile)

add_executable(test_zdotc_fortran test_zdotc_fortran.f90)
target_link_libraries(test_zdotc_fortran ${LIBS} flexiblas cscutils ${LIBS})

add_executable(demo_api_standalone_all demo_api_standalone.c)
add_executable(demo_api_standalone_allinv demo_api_standalone.c)

add_executable(demo_api_standalone_fb demo_api_standalone.c)
add_executable(demo_api_standalone_api demo_api_standalone.c)

target_link_libraries(demo_api_standalone_all flexiblas flexiblas_api)
target_link_libraries(demo_api_standalone_allinv flexiblas_api flexiblas)
target_link_libraries(demo_api_standalone_fb  flexiblas )
target_link_libraries(demo_api_standalone_api flexiblas_api)

SET_TARGET_PROPERTIES (demo_api_standalone_allinv PROPERTIES COMPILE_FLAGS "-DLINK_BLAS")
SET_TARGET_PROPERTIES (demo_api_standalone_all PROPERTIES COMPILE_FLAGS "-DLINK_BLAS")
SET_TARGET_PROPERTIES (demo_api_standalone_fb PROPERTIES COMPILE_FLAGS "-DLINK_BLAS")




#
# Netlib Benchmark
#
add_executable (benchmark.NETLIB benchmark.c)
target_link_libraries (benchmark.NETLIB flexiblas_netlib cscutils ${LIBS})
SET_TARGET_PROPERTIES (benchmark.NETLIB PROPERTIES COMPILE_FLAGS "${EXTRA_FLAGS} -DSTANDALONE -DBACKEND=\\\"NETLIB\\\"")


IF (CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
add_executable (benchmark_overhead_quickreturn.NETLIB benchmark_overhead_quickreturn.c)
target_link_libraries (benchmark_overhead_quickreturn.NETLIB flexiblas_netlib cscutils ${LIBS})
SET_TARGET_PROPERTIES (benchmark_overhead_quickreturn.NETLIB PROPERTIES COMPILE_FLAGS "${EXTRA_FLAGS} -DSTANDALONE -DBACKEND=\\\"NETLIB\\\"")
ENDIF()

MESSAGE(STATUS "Build Extra Benchmarks")
FOREACH(EBLAS ${EXTRA_BLAS})
	UNSET(BLAS_LIBS)
	UNSET(EXTRA_BLAS)
	UNSET(LINKER_FLAGS)
	SET(BLAS_LIBS ${${EBLAS}_BLAS_LIBRARIES})
	SET(EXTRA_FLAGS ${${EBLAS}_BLAS_EXTRA_FLAGS})
	SET(LINKER_FLAGS ${${EBLAS}_BLAS_LINKER_FLAGS})

	MESSAGE(STATUS "${EBLAS} - ${BLAS_LIBS} - ${LINKER_FLAGS}")
	add_executable (benchmark.${EBLAS} benchmark.c)

	target_link_libraries (benchmark.${EBLAS} ${BLAS_LIBS} cscutils ${LIBS})
	SET_TARGET_PROPERTIES (benchmark.${EBLAS} PROPERTIES COMPILE_FLAGS "${EXTRA_FLAGS} -DSTANDALONE -DBACKEND=\\\"${EBLAS}\\\"" LINK_FLAGS "${LINKER_FLAGS}")
	# MESSAGE(STATUS " - ${EBLAS}")


    IF (CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
        add_executable (benchmark_overhead_quickreturn.${EBLAS} benchmark_overhead_quickreturn.c)
    	target_link_libraries (benchmark_overhead_quickreturn.${EBLAS} ${BLAS_LIBS} cscutils ${LIBS})
	    SET_TARGET_PROPERTIES (benchmark_overhead_quickreturn.${EBLAS} PROPERTIES COMPILE_FLAGS "${EXTRA_FLAGS} -DSTANDALONE -DBACKEND=\\\"${EBLAS}\\\"" LINK_FLAGS "${LINKER_FLAGS}")
    ENDIF()

ENDFOREACH()

=== libcscutils/CMakeLists.txt ===
PROJECT(libcscutils C )
CMAKE_MINIMUM_REQUIRED(VERSION 3.5)
LIST(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/CMakeModules")

INCLUDE(SetPolicy)
SET_POLICY(CMP0075 NEW)
SET_POLICY(CMP0063 NEW)

INCLUDE(EnablePedanticC)

IF(NOT ${CMAKE_SOURCE_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
    MESSAGE(STATUS "libcscutils in project build")
    SET(BUILD_SHARED_LIBS OFF)
    SET(DOCS OFF)
    SET(INPROJECT TRUE)
    SET(STANDALONE FALSE)
ELSE()
    SET(STANDALONE TRUE)
    SET(INPROJECT FALSE)
ENDIF()

IF (STANDALONE)
    MESSAGE(STATUS "Standalone build.")
    OPTION(DEBUG "Debug Mode" OFF)
    OPTION(BUILD_SHARED_LIBS "Build shared libs" OFF)
    OPTION(DOCS   "Build API documentation" ON)
    OPTION(FORTRAN "Build with Fortran support" ON)
    OPTION(TESTS "Build tests" ON)

    IF (FORTRAN)
        INCLUDE(CheckLanguage)
        CHECK_LANGUAGE(Fortran)
        IF(CMAKE_Fortran_COMPILER)
            ENABLE_LANGUAGE(Fortran)
        ELSE()
            MESSAGE(FATAL_ERROR "Fortran compiler not found. Please turn off the Fortran support using -DFORTRAN=OFF")
        ENDIF()
    ENDIF()
ENDIF()


set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_C_STANDARD_REQUIRED 11)




IF( NOT CMAKE_BUILD_TYPE )
    SET( CMAKE_BUILD_TYPE "Release" )
ENDIF()

IF(DEBUG STREQUAL ON)
    SET( CMAKE_BUILD_TYPE "Debug" )
ENDIF()

#Options for the IO
OPTION(CSC_ZLIB  "Build ZLIB IO Support" ON)
OPTION(CSC_BZIP2 "Build BZIP2 IO Support" ON)
OPTION(CSC_LIBLZMA "Build LZMA IO Support" ON)
OPTION(CSC_ZSTD    "Build ZSTD HDF5 IO Support" ON)

OPTION(CSC_MMAP "Build with MMAP Support" OFF)

# Setup destination
SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
# FILE(COPY ${PROJECT_SOURCE_DIR}/include DESTINATION ${PROJECT_BINARY_DIR})
SET(CMAKE_Fortran_MODULE_DIRECTORY "${PROJECT_BINARY_DIR}/include/cscutils")

# Required Addons
INCLUDE(CheckIncludeFiles)
INCLUDE(CCompilerSettings)
INCLUDE(CXXCompilerSettings)
INCLUDE(FortranCompilerSettings)

# Compile Options
SET(LIBS ${LIBRARIES} "m")
SET(INCLUDE_DIR ${INCLUDE_DIR} ${PROJECT_BINARY_DIR}/include)

# Include Helpers
INCLUDE(CheckTypeSize)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckIncludeFiles)
INCLUDE(CheckAttributeExists)
INCLUDE(CheckFeatureNeeded)
INCLUDE(ExternalProject)
INCLUDE(CheckSymbolExists)
INCLUDE(CheckCCompilerFlag)
INCLUDE(CheckBlasZdotcMKL)
INCLUDE(CMakeHelpers)

#
# DECOMPOSE_FEATURES
#
IF(NOT CSCUTILS_FEATURES)
    SET(CSCUTILS_FEATURES "inifile;io;threading;hdf5;image;hardware;ds;trace;lua")
ENDIF()

MESSAGE_COLOR("")
MESSAGE_COLOR(STATUS COLOR_BOLD_GREEN "LIBCSCUTILS Features")
FOREACH(FEAT ${CSCUTILS_FEATURES})
    MESSAGE(STATUS "Enable module: ${FEAT}")
    STRING(TOUPPER ${FEAT} _FEAT)
    SET(${_FEAT}_ENABLE TRUE)
ENDFOREACH()



#
# Check for Libraries
#
MACRO(CHECK_LIB PREFIX PACKAGE_NAME NO_DEFINE CONFIG_DEFINE)
    STRING(TOUPPER ${PACKAGE_NAME} _PACKAGE_NAME)
    IF(NOT ${PREFIX}_${CONFIG_DEFINE} STREQUAL OFF)
        MESSAGE_COLOR(STATUS COLOR_GREEN "Search for ${PACKAGE_NAME}")
        FIND_PACKAGE(${PACKAGE_NAME})
        IF(${_PACKAGE_NAME}_FOUND)
            SET(INCLUDE_DIR ${INCLUDE_DIR} ${${_PACKAGE_NAME}_INCLUDE_DIR})
            SET(LIBS ${${_PACKAGE_NAME}_LIBRARIES} ${LIBS})
            MESSAGE(STATUS "${PACKAGE_NAME} found (LIB = ${${_PACKAGE_NAME}_LIBRARIES}, INCLUDE = ${${_PACKAGE_NAME}_INCLUDE_DIR})")
            SET(CSC_HAVE_${CONFIG_DEFINE} TRUE)
        ELSE()
            MESSAGE(STATUS "${PACKAGE_NAME} not found. Deactivating.")
            ADD_DEFINITIONS(-D${NO_DEFINE})
            SET(CSC_HAVE_${CONFIG_DEFINE} FALSE)
        ENDIF()
    ELSE()
        MESSAGE_COLOR(STATUS COLOR_RED "${PACKAGE_NAME} deactivated")
        ADD_DEFINITIONS(-D${NO_DEFINE})
        SET(CSC_HAVE_${CONFIG_DEFINE} FALSE)
    ENDIF()
    UNSET(${_PACKAGE_NAME})
ENDMACRO()

MACRO(CHECK_FUNC FUNC)
    STRING(TOUPPER ${FUNC} _FUNC)
    CHECK_FUNCTION_EXISTS(${FUNC} CSC_HAVE_${_FUNC})
    UNSET(_FUNC)
ENDMACRO()

# Generic Stuff
MESSAGE_COLOR("")
MESSAGE_COLOR(STATUS COLOR_BOLD_BLUE "Check Generic Functionality")

#
#  Check for compiler features
#
CHECK_ATTRIBUTE_EXISTS(constructor CSC_HAVE_ATTR_CONSTRUCTOR)
CHECK_ATTRIBUTE_EXISTS(deprecated  CSC_HAVE_ATTR_DEPRECATED)


FIND_PACKAGE(Threads REQUIRED)
SET(LIBS ${LIBS} ${CMAKE_THREAD_LIBS_INIT})
SET(_X ${CMAKE_REQUIRED_LIBRARIES})
SET(CMAKE_REQUIRED_LIBRARIES ${CMAKE_THREAD_LIBS_INIT} ${CMAKE_REQUIRED_LIBRARIES})
IF(CMAKE_USE_PTHREADS_INIT)
    SET(CSC_HAVE_PTHREAD TRUE)
    CHECK_FEATURE_NEEDED(pthread_yield pthread.h CSC_HAVE_PTHREAD_YIELD PTHREAD_YIELD_FEATURE)
ENDIF()
SET(CMAKE_REQUIRED_LIBRARIES ${_X})

#
# Common FEATURES
#
CHECK_INCLUDE_FILES(execinfo.h HAVE_EXECINFO)
CHECK_FUNCTION_EXISTS(backtrace CSC_HAVE_BACKTRACE)
CHECK_FUNCTION_EXISTS(backtrace_symbols HAVE_BACKTRACE_SYMBOLS)
IF(HAVE_EXECINFO AND CSC_HAVE_BACKTRACE AND HAVE_BACKTRACE_SYMBOLS)
    MESSAGE_COLOR(STATUS COLOR_MAGENTA "Enable csc_show_backtrace.")
ENDIF()

CHECK_FEATURE_NEEDED(strnlen string.h CSC_HAVE_STRNLEN STRNLEN_FEATURE "_WITH_STRNLEN")
IF( CSC_HAVE_STRNLEN )
    ADD_DEFINITIONS("${STRNLEN_FEATURE}")
ENDIF()

CHECK_FEATURE_NEEDED(strndup string.h CSC_HAVE_STRNDUP STRNDUP_FEATURE "_WITH_STRNDUP")
IF( CSC_HAVE_STRNDUP )
    ADD_DEFINITIONS("${STRNDUP_FEATURE}")
ENDIF()


# check needed include files for csc_get_term_width
CHECK_INCLUDE_FILES(sys/ioctl.h CSC_HAVE_IOCTL)
CHECK_INCLUDE_FILES(unistd.h    CSC_HAVE_UNISTD)

CHECK_FEATURE_NEEDED(getline stdio.h CSC_HAVE_GETLINE GETLINE_FEATURE "_WITH_GETLINE")
IF( CSC_HAVE_GETLINE )
    ADD_DEFINITIONS("${GETLINE_FEATURE}")
ENDIF()

CHECK_FEATURE_NEEDED(getdelim stdio.h CSC_HAVE_GETDELIM GETDELIM_FEATURE "_WITH_GETDELIM")
IF( CSC_HAVE_GETDELIM )
    ADD_DEFINITIONS("${GETDELIM_FEATURE}")
ENDIF()

IF(INIFILE_ENABLE)
    MESSAGE_COLOR("")
    MESSAGE_COLOR(STATUS COLOR_BOLD_BLUE "Features for CSC-INIFILE")

    IF (NOT WIN32)
        CHECK_FEATURE_NEEDED(realpath stdlib.h CSC_HAVE_REALPATH REALPATH_FEATURE)
        IF(CSC_HAVE_REALPATH)
            ADD_DEFINITIONS("${REALPATH_FEATURE}")
        ELSE()
            MESSAGE(FATAL_ERROR "realpath not found")
        ENDIF()
    ENDIF()
ENDIF()

IF(IO_ENABLE)
    MESSAGE_COLOR("")
    MESSAGE_COLOR(STATUS COLOR_BOLD_BLUE "Features for CSC-IO")

    # IO_ZLIB
    CHECK_FUNC(vsscanf)
    CHECK_FUNC(vsnprintf)

    CHECK_INCLUDE_FILES(sys/types.h CSC_HAVE_SYS_TYPES)
    IF(CSC_HAVE_SYS_TYPES)
        SET(CMAKE_EXTRA_INCLUDE_FILES ${CMAKE_EXTRA_INCLUDE_FILES} sys/types.h)
    ENDIF()
    CHECK_INCLUDE_FILES(sys/stat.h  CSC_HAVE_SYS_STAT)
    IF(CSC_HAVE_SYS_STAT)
        SET(CMAKE_EXTRA_INCLUDE_FILES ${CMAKE_EXTRA_INCLUDE_FILES} sys/stat.h)
    ENDIF()
    CHECK_INCLUDE_FILES(fcntl.h     CSC_HAVE_FCNTL)
    IF(CSC_HAVE_FCNTL)
        SET(CMAKE_EXTRA_INCLUDE_FILES ${CMAKE_EXTRA_INCLUDE_FILES} fcntl.h)
    ENDIF()
    CHECK_INCLUDE_FILES(sys/mman.h     CSC_HAVE_SYS_MMAN)
    IF(CSC_HAVE_SYS_MMAN)
        SET(CMAKE_EXTRA_INCLUDE_FILES ${CMAKE_EXTRA_INCLUDE_FILES} sys/mman.h)
    ENDIF()

    CHECK_FUNCTION_EXISTS(open CSC_HAVE_OPEN)
    CHECK_FUNCTION_EXISTS(mmap CSC_HAVE_MMAP)
    CHECK_FUNCTION_EXISTS(lseek CSC_HAVE_LSEEK)
    SET(CSC_IO_MMAP_IO FALSE)
    IF( CSC_IO_MMAP AND CSC_HAVE_LSEEK AND CSC_HAVE_MMAP AND CSC_HAVE_OPEN ) #CSC_IO_MMAP is an option which can be turned off
        SET(CSC_HAVE_MMAP_IO TRUE)
        MESSAGE_COLOR(STATUS COLOR_MAGENTA "Enable memory mapped IO")
    ELSE()
        SET(CSC_IO_MMAP_IO FALSE)
    ENDIF()
ENDIF()

IF(TRACE_ENABLE)
    MESSAGE_COLOR("")
    MESSAGE_COLOR(STATUS COLOR_BOLD_BLUE "Features for CSC-Tracewriter")

    FIND_PACKAGE(OpenMP)
    IF(OPENMP_FOUND)
        SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
        SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
        SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${OpenMP_Fortran_FLAGS}")
    ENDIF()
ENDIF()


# Common External Libraries
MESSAGE_COLOR("")
MESSAGE_COLOR(STATUS COLOR_BOLD_BLUE "External Libraries")

IF( IO_ENABLE OR HDF5_ENABLE )
    CHECK_LIB(CSC ZLIB NO_GZ ZLIB)
    CHECK_LIB(CSC BZip2 NO_BZ2 BZIP2)
    CHECK_LIB(CSC LibLZMA NO_XZ LZMA)
    CHECK_LIB(CSC ZSTD  NO_ZSTD ZSTD)
ENDIF()

IF (CMAKE_C_COMPILER_ID STREQUAL "TinyCC")
    MESSAGE(STATUS "TinyCC does not support complex numbers. Deactivating HDF5 support")
    SET( HDF5_ENABLE FALSE)
ENDIF()

IF(HDF5_ENABLE)
    MESSAGE_COLOR("")
    MESSAGE_COLOR(STATUS COLOR_BOLD_BLUE "Search HDF5")

    FIND_PACKAGE(HDF5 COMPONENTS C HL REQUIRED)
    SET(LIBS ${LIBS} ${HDF5_LIBRARIES} ${HDF5_HL_LIBRARIES})
    SET(INCLUDE_DIR ${INCLUDE_DIR} ${HDF5_INCLUDE_DIRS})
    ADD_DEFINITIONS(${HDF5_DEFINITIONS})
    SET(CSC_HAVE_HDF5 TRUE)

    SET(_CMAKE_REQUIRED_DEFINITIONS ${CMAKE_REQUIRED_DEFINITIONS})  #list of macros to define (-DFOO=bar)
    SET(_CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES})  #list of include directories
    SET(_CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES}) #list of libraries to link
    SET(_CMAKE_EXTRA_INCLUDE_FILES ${CMAKE_EXTRA_INCLUDE_FILES}) # list of extra headers to include

    SET (CMAKE_REQUIRED_DEFINITIONS ${HDF5_DEFINITIONS})
    SET (CMAKE_REQUIRED_INCLUDES ${HDF5_INCLUDE_DIRS})
    SET (CMAKE_REQUIRED_LIBRARIES ${HDF5_LIBRARIES} ${HDF5_HL_LIBRARIES})
    SET (CMAKE_EXTRA_INCLUDE_FILES hdf5.h)

    CHECK_TYPE_SIZE(hid_t HDF5_HID_SIZE)
    MESSAGE(STATUS "Size of HDF5 hid_t: ${HDF5_HID_SIZE}")
    ADD_DEFINITIONS(-DHDF5_HID_SIZE=${HDF5_HID_SIZE})
    SET(CMAKE_REQUIRED_DEFINITIONS ${_CMAKE_REQUIRED_DEFINITIONS})  #list of macros to define (-DFOO=bar)
    SET(CMAKE_REQUIRED_INCLUDES ${_CMAKE_REQUIRED_INCLUDES})  #list of include directories
    SET(CMAKE_REQUIRED_LIBRARIES ${_CMAKE_REQUIRED_LIBRARIES}) #list of libraries to link
    SET(CMAKE_EXTRA_INCLUDE_FILES ${_CMAKE_EXTRA_INCLUDE_FILES}) # list of extra headers to include

ENDIF()

FIND_PACKAGE(CPUFREQ)
IF(CPUFREQ_FOUND)
    SET(LIBS ${CPUFREQ_LIBRARIES} ${LIBS})
    INCLUDE_DIRECTORIES(${CPUFREQ_INCLUDE_DIR})
    SET(CSC_HAVE_CPUFREQ TRUE)
ELSE()
    SET(CSC_HAVE_CPUFREQ FALSE)
    MESSAGE("CPUFREQ not found. Either cpufreq.h or libcpupower.so is missing.")
ENDIF()

#
# Add LUA
#
IF( LUA_ENABLE)
    ADD_SUBDIRECTORY(contrib/lua)
    SET(LIBS lua ${LIBS})
    SET(INCLUDE_DIR ${INCLUDE_DIR} ${PROJECT_BINARY_DIR}/contrib/lua/include)
    IF (NOT CMAKE_C_COMPILER_ID STREQUAL "TinyCC")
        SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--exclude-libs=liblua.a")
    ENDIF()
ENDIF()

CONFIGURE_FILE(config.h.in ${PROJECT_BINARY_DIR}/include/cscutils/cscutils_config.h @ONLY)

# Find additional Libraries
ADD_SUBDIRECTORY(src)
IF(NOT INPROJECT)
    ADD_SUBDIRECTORY(examples)
ENDIF()

IF(TESTS STREQUAL ON)
    ENABLE_TESTING()
    IF(HDF5_ENABLE)
        ADD_SUBDIRECTORY(tests/hdf5)
    ENDIF()


ENDIF()

IF(DOCS STREQUAL ON)
    MESSAGE_COLOR("")
    MESSAGE_COLOR(STATUS COLOR_BOLD_BLUE "Documentation")

    SET(DOXYFILE_OUTPUT_DIR "${PROJECT_BINARY_DIR}/doc")
    SET(DOXYFILE_LATEX_DIR  "${PROJECT_BINARY_DIR}/doc/latex")
    SET(LATEX_COMPILER "pdflatex")
    # set(DOXYFILE_EXTRA_SOURCES "${CMAKE_SOURCE_DIR}/documents/category.dox")
    SET(DOXYFILE_LATEX OFF)
    SET(DOXYFILE_GENERATE_LATEX YES)
    SET(USE_PDFLATEX YES)

    #set(PROJECT_VERSION ${MESS_VERSION})

    INCLUDE(UseDoxygen OPTIONAL)
    #  IF ( DOXYGEN_FOUND )
    #  file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/doc/html/misc)
    #  file(COPY ${CMAKE_SOURCE_DIR}/documents/doc_style.css DESTINATION  ${CMAKE_BINARY_DIR}/doc/html/misc/)
    #ENDIF (DOXYGEN_FOUND)
ENDIF()

IF (NOT INPROJECT)
    MESSAGE_COLOR("")
    MESSAGE_COLOR(STATUS COLOR_BOLD_BLUE "LIBCSCUTILS -- Final Configuration")
    SHOW_PROJECT_INFO()
ENDIF()

=== src/CMakeLists.txt ===

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/flexiblas_api.h.in ${CMAKE_BINARY_DIR}/include/flexiblas_api.h)


ADD_SUBDIRECTORY(fallback_blas)

IF(LAPACK)
ADD_SUBDIRECTORY(fallback_lapack)
ENDIF()

SET (COMMON_SRC
	mgmt/hooks.c
	mgmt.c
    paths.c
    hooks.c
    utils.c
    sh_utils.c
	flexiblas_printf.c
    common.c
)

SET ( SRC
	flexiblas.c
	flexiblas_api.c
	loader.c
	hook_loader.c
	xerbla.c
	lsame.c
	set_num_threads.c
	wrap_cblas.c
    cabs.c
    ${COMMON_SRC}
)

SET (FLEXIBLAS_MGMT_SRC
    ${COMMON_SRC}
)

SET (FLEXIBLAS_API_SRC
	flexiblas_api_standalone.c
)

IF ( FLEXIBLAS_ABI_INTEL)
	SET (SRC ${SRC} wrapper_blas_intel.c)
ELSE ()
	SET (SRC ${SRC} wrapper_blas_gnu.c)
ENDIF()


SET ( CBLAS_SRC
	# Globlas
	cblas_interface/cblas_globals.c
	cblas_interface/cblas_xerbla.c
	# Double
	cblas_interface/cblas_dasum.c
	cblas_interface/cblas_daxpy.c
	cblas_interface/cblas_dcopy.c
	cblas_interface/cblas_ddot.c
	cblas_interface/cblas_dgbmv.c
	cblas_interface/cblas_dgemm.c
	cblas_interface/cblas_dgemv.c
	cblas_interface/cblas_dger.c
	cblas_interface/cblas_dnrm2.c
	cblas_interface/cblas_drot.c
	cblas_interface/cblas_drotg.c
	cblas_interface/cblas_drotm.c
	cblas_interface/cblas_drotmg.c
	cblas_interface/cblas_dsbmv.c
	cblas_interface/cblas_dscal.c
	cblas_interface/cblas_dsdot.c
	cblas_interface/cblas_dspmv.c
	cblas_interface/cblas_dspr.c
	cblas_interface/cblas_dspr2.c
	cblas_interface/cblas_dswap.c
	cblas_interface/cblas_dsymm.c
	cblas_interface/cblas_dsymv.c
	cblas_interface/cblas_dsyr.c
	cblas_interface/cblas_dsyr2.c
	cblas_interface/cblas_dsyr2k.c
	cblas_interface/cblas_dsyrk.c
	cblas_interface/cblas_dtbmv.c
	cblas_interface/cblas_dtbsv.c
	cblas_interface/cblas_dtpmv.c
	cblas_interface/cblas_dtpsv.c
	cblas_interface/cblas_dtrmm.c
	cblas_interface/cblas_dtrmv.c
	cblas_interface/cblas_dtrsm.c
	cblas_interface/cblas_dtrsv.c
	cblas_interface/cblas_dzasum.c
	cblas_interface/cblas_dznrm2.c
	cblas_interface/cblas_idamax.c
	# Single
	cblas_interface/cblas_sasum.c
	cblas_interface/cblas_saxpy.c
	cblas_interface/cblas_scasum.c
	cblas_interface/cblas_scnrm2.c
	cblas_interface/cblas_scopy.c
	cblas_interface/cblas_sdot.c
	cblas_interface/cblas_sdsdot.c
	cblas_interface/cblas_sgbmv.c
	cblas_interface/cblas_sgemm.c
	cblas_interface/cblas_sgemv.c
	cblas_interface/cblas_sger.c
	cblas_interface/cblas_snrm2.c
	cblas_interface/cblas_srot.c
	cblas_interface/cblas_srotg.c
	cblas_interface/cblas_srotm.c
	cblas_interface/cblas_srotmg.c
	cblas_interface/cblas_ssbmv.c
	cblas_interface/cblas_sscal.c
	cblas_interface/cblas_sspmv.c
	cblas_interface/cblas_sspr2.c
	cblas_interface/cblas_sspr.c
	cblas_interface/cblas_sswap.c
	cblas_interface/cblas_ssymm.c
	cblas_interface/cblas_ssymv.c
	cblas_interface/cblas_ssyr2.c
	cblas_interface/cblas_ssyr2k.c
	cblas_interface/cblas_ssyr.c
	cblas_interface/cblas_ssyrk.c
	cblas_interface/cblas_stbmv.c
	cblas_interface/cblas_stbsv.c
	cblas_interface/cblas_stpmv.c
	cblas_interface/cblas_stpsv.c
	cblas_interface/cblas_strmm.c
	cblas_interface/cblas_strmv.c
	cblas_interface/cblas_strsm.c
	cblas_interface/cblas_strsv.c
	cblas_interface/cblas_isamax.c
	# Complex Single
	cblas_interface/cblas_caxpy.c
	cblas_interface/cblas_ccopy.c
	cblas_interface/cblas_cdotc_sub.c
	cblas_interface/cblas_cdotu_sub.c
	cblas_interface/cblas_cgbmv.c
	cblas_interface/cblas_cgemm.c
	cblas_interface/cblas_cgemv.c
	cblas_interface/cblas_cgerc.c
	cblas_interface/cblas_cgeru.c
	cblas_interface/cblas_chbmv.c
	cblas_interface/cblas_chemm.c
	cblas_interface/cblas_chemv.c
	cblas_interface/cblas_cher2.c
	cblas_interface/cblas_cher2k.c
	cblas_interface/cblas_cher.c
	cblas_interface/cblas_cherk.c
	cblas_interface/cblas_chpmv.c
	cblas_interface/cblas_chpr2.c
	cblas_interface/cblas_chpr.c
	cblas_interface/cblas_crotg.c
	cblas_interface/cblas_csrot.c
	cblas_interface/cblas_cscal.c
	cblas_interface/cblas_csscal.c
	cblas_interface/cblas_cswap.c
	cblas_interface/cblas_csymm.c
	cblas_interface/cblas_csyr2k.c
	cblas_interface/cblas_csyrk.c
	cblas_interface/cblas_ctbmv.c
	cblas_interface/cblas_ctbsv.c
	cblas_interface/cblas_ctpmv.c
	cblas_interface/cblas_ctpsv.c
	cblas_interface/cblas_ctrmm.c
	cblas_interface/cblas_ctrmv.c
	cblas_interface/cblas_ctrsm.c
	cblas_interface/cblas_ctrsv.c
	cblas_interface/cblas_icamax.c
	# Complex Double
	cblas_interface/cblas_zaxpy.c
	cblas_interface/cblas_zcopy.c
	cblas_interface/cblas_zdotc_sub.c
	cblas_interface/cblas_zdotu_sub.c
	cblas_interface/cblas_zgbmv.c
	cblas_interface/cblas_zgemm.c
	cblas_interface/cblas_zgemv.c
	cblas_interface/cblas_zgerc.c
	cblas_interface/cblas_zgeru.c
	cblas_interface/cblas_zhbmv.c
	cblas_interface/cblas_zhemm.c
	cblas_interface/cblas_zhemv.c
	cblas_interface/cblas_zher2.c
	cblas_interface/cblas_zher2k.c
	cblas_interface/cblas_zher.c
	cblas_interface/cblas_zherk.c
	cblas_interface/cblas_zhpmv.c
	cblas_interface/cblas_zhpr2.c
	cblas_interface/cblas_zhpr.c
    cblas_interface/cblas_zrotg.c
    cblas_interface/cblas_zdrot.c
	cblas_interface/cblas_zscal.c
	cblas_interface/cblas_zdscal.c
	cblas_interface/cblas_zswap.c
	cblas_interface/cblas_zsymm.c
    cblas_interface/cblas_zsyr2k.c
	cblas_interface/cblas_zsyrk.c
	cblas_interface/cblas_ztbmv.c
	cblas_interface/cblas_ztbsv.c
	cblas_interface/cblas_ztpmv.c
	cblas_interface/cblas_ztpsv.c
	cblas_interface/cblas_ztrmm.c
	cblas_interface/cblas_ztrmv.c
	cblas_interface/cblas_ztrsm.c
	cblas_interface/cblas_ztrsv.c
	cblas_interface/cblas_izamax.c
    cblas_interface/cblas_daxpby.c
    cblas_interface/cblas_saxpby.c
    cblas_interface/cblas_caxpby.c
    cblas_interface/cblas_zaxpby.c
    cblas_interface/cblas_simatcopy.c
    cblas_interface/cblas_dimatcopy.c
    cblas_interface/cblas_cimatcopy.c
    cblas_interface/cblas_zimatcopy.c
    cblas_interface/cblas_somatcopy.c
    cblas_interface/cblas_domatcopy.c
    cblas_interface/cblas_comatcopy.c
    cblas_interface/cblas_zomatcopy.c
    cblas_interface/cblas_dgeadd.c
    cblas_interface/cblas_cgeadd.c
    cblas_interface/cblas_zgeadd.c
    cblas_interface/cblas_sgeadd.c


    )
IF (CBLAS STREQUAL ON)
	SET (SRC ${SRC} ${CBLAS_SRC})
ENDIF()

#
# LAPACK
#
IF ( LAPACK )
	# 3.7.1 and 3.7.0 share the same api/abi
	IF(LAPACK_API_VERSION STREQUAL "3.12.0")
		SET(_LAPACK_FILE_SUFFIX 3_12_0)
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.12.0-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_12_0-wodprc) #
    ELSEIF(LAPACK_API_VERSION STREQUAL "3.11.0")
		SET(_LAPACK_FILE_SUFFIX 3_11_0)
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.11.0-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_11_0-wodprc) #
    ELSEIF(LAPACK_API_VERSION STREQUAL "3.10.1")
		SET(_LAPACK_FILE_SUFFIX 3_10_1)
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.10.1-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_10_1-wodprc) #
    ELSEIF(LAPACK_API_VERSION STREQUAL "3.10.0")
		SET(_LAPACK_FILE_SUFFIX 3_10_0)
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.10.0-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_10_0-wodprc) #
    ELSEIF(LAPACK_API_VERSION STREQUAL "3.9.1")
		SET(_LAPACK_FILE_SUFFIX 3_9_1)
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.9.1-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_9_1-wodprc) #
    ELSEIF(LAPACK_API_VERSION STREQUAL "3.9.0")
		SET(_LAPACK_FILE_SUFFIX 3_9_0)
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.9.0-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_9_0-wodprc) #
    ELSEIF(LAPACK_API_VERSION STREQUAL "3.8.0")
		SET(_LAPACK_FILE_SUFFIX 3_8_0)
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.8.0-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_8_0-wodprc) #
	ELSEIF(LAPACK_API_VERSION STREQUAL "3.7.1")
		SET(_LAPACK_FILE_SUFFIX 3_7_0)
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.7.1-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_7_0-wodprc) #
	ELSEIF(LAPACK_API_VERSION STREQUAL "3.7.0")
		SET(_LAPACK_FILE_SUFFIX 3_7_0)
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.7.0-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_7_0-wodprc) #
	ELSEIF(LAPACK_API_VERSION STREQUAL "3.6.1")
		SET(_LAPACK_FILE_SUFFIX 3_6_1)
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.6.1-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_6_1-wodprc) #
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.6.0")
		SET(_LAPACK_FILE_SUFFIX 3_6_0) #
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.6.0-wodprc")
		SET(_LAPACK_FILE_SUFFIX 3_6_0-wodprc) #
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.5.0")
		SET(_LAPACK_FILE_SUFFIX 3_5_0) #
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.4.2")
		SET(_LAPACK_FILE_SUFFIX 3_4_2) #
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.4.1")
		SET(_LAPACK_FILE_SUFFIX 3_4_1) #
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.4.0")
		SET(_LAPACK_FILE_SUFFIX 3_4_0) #
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.3.1")
		SET(_LAPACK_FILE_SUFFIX 3_3_1) #
	ELSEIF (LAPACK_API_VERSION STREQUAL "3.3.0")
		SET(_LAPACK_FILE_SUFFIX 3_3_0) #
	ENDIF()
	INCLUDE(lapack_interface/lapack_${_LAPACK_FILE_SUFFIX}.cmake)

	SET (SRC ${SRC} ${LAPACK_SRC} lapack_interface/ilaver.c
		lapack_interface/load_lapack_${_LAPACK_FILE_SUFFIX}.c
        lapack_interface/load_lapack_${_LAPACK_FILE_SUFFIX}_fallback.c
	)

	FILE(COPY lapack_interface/lapack_${_LAPACK_FILE_SUFFIX}.h DESTINATION ${PROJECT_BINARY_DIR}/include/)
	FILE(RENAME  ${PROJECT_BINARY_DIR}/include/lapack_${_LAPACK_FILE_SUFFIX}.h ${PROJECT_BINARY_DIR}/include/lapack.h)
	FILE(COPY lapack_interface/flexiblas_real_lapack_${_LAPACK_FILE_SUFFIX}.h DESTINATION ${PROJECT_BINARY_DIR}/include/)
	FILE(RENAME  ${PROJECT_BINARY_DIR}/include/flexiblas_real_lapack_${_LAPACK_FILE_SUFFIX}.h ${PROJECT_BINARY_DIR}/include/flexiblas_real_lapack.h)

ENDIF()

FIND_PACKAGE(OpenMP)

INCLUDE_DIRECTORIES(${INCLUDE_DIR} ${CMAKE_CURRENT_SOURCE_DIR})
add_library(flexiblas SHARED ${SRC}) #  $<TARGET_OBJECTS:cscutils_src>)
add_executable(flexiblas-tool flexiblas_tool.c tool/hookhandling.c tool/blashandling.c ${COMMON_SRC} ) # $<TARGET_OBJECTS:cscutils_src>)

IF (LINK_OPENMP)
    TARGET_LINK_LIBRARIES(flexiblas ${LIBS} cscutils OpenMP::OpenMP_C)
    TARGET_LINK_LIBRARIES(flexiblas-tool PRIVATE flexiblas_mgmt ${LIBS} cscutils OpenMP::OpenMP_C)
ELSE()
    TARGET_LINK_LIBRARIES(flexiblas ${LIBS} cscutils) # OpenMP::OpenMP_C)
    TARGET_LINK_LIBRARIES(flexiblas-tool PRIVATE flexiblas_mgmt ${LIBS} cscutils) # OpenMP::OpenMP_C)
ENDIF()


add_library(flexiblas_mgmt SHARED ${FLEXIBLAS_MGMT_SRC}) # $<TARGET_OBJECTS:cscutils_src>)
TARGET_LINK_LIBRARIES(flexiblas_mgmt ${LIBS} cscutils )

add_library(flexiblas_api SHARED ${FLEXIBLAS_API_SRC} ) # $<TARGET_OBJECTS:cscutils_src>)
TARGET_LINK_LIBRARIES(flexiblas_api ${DL_LIB} cscutils c)

set(GENERIC_LIB_VERSION "${FLEXIBLAS_VERSION_MAJOR}.${FLEXIBLAS_VERSION_MINOR}")
set(GENERIC_LIB_SOVERSION "${FLEXIBLAS_VERSION_MAJOR}")


add_executable(flexiblas-config flexiblas-config.c)

IF ( C_W_PEDANTIC )
    target_compile_options(flexiblas PRIVATE "-Wpedantic")
    target_compile_options(flexiblas-tool PRIVATE "-Wpedantic")
    target_compile_options(flexiblas_mgmt PRIVATE "-Wpedantic")
    target_compile_options(flexiblas_api PRIVATE "-Wpedantic")
    target_compile_options(flexiblas-config PRIVATE "-Wpedantic")
ENDIF()






IF ( NOT ${CMAKE_C_COMPILER_ID} MATCHES "XL")
 	SET_TARGET_PROPERTIES(flexiblas PROPERTIES VERSION ${GENERIC_LIB_VERSION} SOVERSION ${GENERIC_LIB_SOVERSION} LINK_FLAGS "-Bsymbolic" )
 	SET_TARGET_PROPERTIES(flexiblas_mgmt PROPERTIES VERSION ${GENERIC_LIB_VERSION} SOVERSION ${GENERIC_LIB_SOVERSION} LINK_FLAGS "-Bsymbolic" )
 	SET_TARGET_PROPERTIES(flexiblas_api PROPERTIES VERSION ${GENERIC_LIB_VERSION} SOVERSION ${GENERIC_LIB_SOVERSION} LINK_FLAGS "-Bsymbolic" )
ENDIF()



IF (FLEXIBLAS_ABI_INTEL)
	SET_TARGET_PROPERTIES(flexiblas PROPERTIES OUTPUT_NAME flexiblas_intel)
ENDIF()

IF (FLEXIBLAS_ABI_IBM)
	SET_TARGET_PROPERTIES(flexiblas PROPERTIES OUTPUT_NAME flexiblas_xl)
ENDIF()


IF(INTEGER8 STREQUAL ON)
	SET_TARGET_PROPERTIES(flexiblas      PROPERTIES OUTPUT_NAME ${flexiblasname})
	SET_TARGET_PROPERTIES(flexiblas_api  PROPERTIES OUTPUT_NAME ${flexiblasname}_api)
	SET_TARGET_PROPERTIES(flexiblas_mgmt PROPERTIES OUTPUT_NAME ${flexiblasname}_mgmt)
	SET_TARGET_PROPERTIES(flexiblas-tool PROPERTIES OUTPUT_NAME ${flexiblasname})
    SET_TARGET_PROPERTIES(flexiblas-config PROPERTIES OUTPUT_NAME ${flexiblasname}-config)

	IF (USE_INTERFACE_INTEL)

=== contributed/lapack-3.10.0/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
CheckPolicy(CMP0048 NEW)
project(LAPACK Fortran C)

set(LAPACK_MAJOR_VERSION 3)
set(LAPACK_MINOR_VERSION 10)
set(LAPACK_PATCH_VERSION 0)
set(
  LAPACK_VERSION
  ${LAPACK_MAJOR_VERSION}.${LAPACK_MINOR_VERSION}.${LAPACK_PATCH_VERSION}
  )

# Add the CMake directory for custon CMake modules
set(CMAKE_MODULE_PATH "${LAPACK_SOURCE_DIR}/CMAKE" ${CMAKE_MODULE_PATH})

if(UNIX)
  if("${CMAKE_Fortran_COMPILER}" MATCHES "ifort")
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fp-model strict")
  endif()
  if("${CMAKE_Fortran_COMPILER}" MATCHES "xlf")
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -qnosave -qstrict=none")
  endif()
# Delete libmtsk in linking sequence for Sun/Oracle Fortran Compiler.
# This library is not present in the Sun package SolarisStudio12.3-linux-x86-bin
  string(REPLACE \;mtsk\; \; CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES "${CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES}")
endif()

if(CMAKE_Fortran_COMPILER_ID STREQUAL "Compaq")
  if(WIN32)
    if(CMAKE_GENERATOR STREQUAL "NMake Makefiles")
      get_filename_component(CMAKE_Fortran_COMPILER_CMDNAM ${CMAKE_Fortran_COMPILER} NAME_WE)
      message(STATUS "Using Compaq Fortran compiler with command name ${CMAKE_Fortran_COMPILER_CMDNAM}")
      set(cmd ${CMAKE_Fortran_COMPILER_CMDNAM})
      string(TOLOWER "${cmd}" cmdlc)
      if(cmdlc STREQUAL "df")
        message(STATUS "Assume the Compaq Visual Fortran Compiler is being used")
        set(CMAKE_Fortran_USE_RESPONSE_FILE_FOR_OBJECTS 1)
        set(CMAKE_Fortran_USE_RESPONSE_FILE_FOR_INCLUDES 1)
        #This is a workaround that is needed to avoid forward-slashes in the
        #filenames listed in response files from incorrectly being interpreted as
        #introducing compiler command options
        if(${BUILD_SHARED_LIBS})
          message(FATAL_ERROR "Making of shared libraries with CVF has not been tested.")
        endif()
        set(str "NMake version 9 or later should be used. NMake version 6.0 which is\n")
        set(str "${str}   included with the CVF distribution fails to build Lapack because\n")
        set(str "${str}   the number of source files exceeds the limit for NMake v6.0\n")
        message(STATUS ${str})
        set(CMAKE_Fortran_LINK_EXECUTABLE "LINK /out:<TARGET> <LINK_FLAGS> <LINK_LIBRARIES> <OBJECTS>")
      endif()
    endif()
  endif()
endif()

# Disable Warings for BLAS
if ( CMAKE_Fortran_COMPILER_ID STREQUAL "GNU" )
	SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -ffloat-store -Wno-conversion -Wno-maybe-uninitialized -Wno-unused-dummy-argument -Wno-unused-variable -Wno-intrinsic-shadow -Wno-surprising -Wno-character-truncation")
endif()

# --------------------------------------------------
# Check for any necessary platform specific compiler flags
include(CheckLAPACKCompilerFlags)
CheckLAPACKCompilerFlags()

IF ( INTEGER8 STREQUAL ON )
	SET (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${I8_FLAGS}")
	ADD_DEFINITIONS(-DINTEGER8)
ENDIF()

# --------------------------------------------------
# Check second function

include(CheckTimeFunction)
set(TIME_FUNC NONE ${TIME_FUNC})
CHECK_TIME_FUNCTION(NONE TIME_FUNC)
CHECK_TIME_FUNCTION(INT_CPU_TIME TIME_FUNC)
CHECK_TIME_FUNCTION(EXT_ETIME TIME_FUNC)
CHECK_TIME_FUNCTION(EXT_ETIME_ TIME_FUNC)
CHECK_TIME_FUNCTION(INT_ETIME TIME_FUNC)
message(STATUS "--> Will use second_${TIME_FUNC}.f and dsecnd_${TIME_FUNC}.f as timing function.")

set(SECOND_SRC ${LAPACK_SOURCE_DIR}/INSTALL/second_${TIME_FUNC}.f)
set(DSECOND_SRC ${LAPACK_SOURCE_DIR}/INSTALL/dsecnd_${TIME_FUNC}.f)

add_subdirectory(SRC)

=== contributed/lapack-3.10.1/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

project(LAPACK Fortran C)

set(LAPACK_MAJOR_VERSION 3)
set(LAPACK_MINOR_VERSION 10)
set(LAPACK_PATCH_VERSION 1)
set(
  LAPACK_VERSION
  ${LAPACK_MAJOR_VERSION}.${LAPACK_MINOR_VERSION}.${LAPACK_PATCH_VERSION}
  )

# Add the CMake directory for custom CMake modules
set(CMAKE_MODULE_PATH "${LAPACK_SOURCE_DIR}/CMAKE" ${CMAKE_MODULE_PATH})

# Export all symbols on Windows when building shared libraries
SET(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo" "Coverage")
endif()

include(PreventInSourceBuilds)
include(PreventInBuildInstalls)

# Check if recursive flag exists
include(CheckFortranCompilerFlag)
if(CMAKE_Fortran_COMPILER_ID STREQUAL Flang)
  check_fortran_compiler_flag("-Mrecursive" _MrecursiveFlag)
elseif(CMAKE_Fortran_COMPILER_ID STREQUAL GNU)
  check_fortran_compiler_flag("-frecursive" _frecursiveFlag)
elseif(CMAKE_Fortran_COMPILER_ID STREQUAL Intel)
  check_fortran_compiler_flag("-recursive" _recursiveFlag)
elseif(CMAKE_Fortran_COMPILER_ID STREQUAL XL)
  check_fortran_compiler_flag("-qrecur" _qrecurFlag)
else()
  message(WARNING "Fortran local arrays should be allocated on the stack."
    " Please use a compiler which guarantees that feature."
    " See https://github.com/Reference-LAPACK/lapack/pull/188 and references therein.")
endif()

# Add recursive flag
if(_MrecursiveFlag)
  string(REGEX MATCH "-Mrecursive" output_test <string> "${CMAKE_Fortran_FLAGS}")
  if(NOT output_test)
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -Mrecursive"
      CACHE STRING "Recursive flag must be set" FORCE)
  endif()
elseif(_frecursiveFlag)
  string(REGEX MATCH "-frecursive" output_test <string> "${CMAKE_Fortran_FLAGS}")
  if(NOT output_test)
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -frecursive"
      CACHE STRING "Recursive flag must be set" FORCE)
  endif()
elseif(_recursiveFlag)
  string(REGEX MATCH "-recursive" output_test <string> "${CMAKE_Fortran_FLAGS}")
  if(NOT output_test)
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -recursive"
      CACHE STRING "Recursive flag must be set" FORCE)
  endif()
elseif(_qrecurFlag)
  string(REGEX MATCH "-qrecur" output_test <string> "${CMAKE_Fortran_FLAGS}")
  if(NOT output_test)
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -qrecur"
      CACHE STRING "Recursive flag must be set" FORCE)
  endif()
endif()

if(UNIX)
  if(CMAKE_Fortran_COMPILER_ID STREQUAL Intel)
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fp-model strict")
  endif()
  if(CMAKE_Fortran_COMPILER_ID STREQUAL XL)
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -qnosave -qstrict")
  endif()
# Delete libmtsk in linking sequence for Sun/Oracle Fortran Compiler.
# This library is not present in the Sun package SolarisStudio12.3-linux-x86-bin
  string(REPLACE \;mtsk\; \; CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES "${CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES}")
endif()

if(CMAKE_Fortran_COMPILER_ID STREQUAL Compaq)
  if(WIN32)
    if(CMAKE_GENERATOR STREQUAL "NMake Makefiles")
      get_filename_component(CMAKE_Fortran_COMPILER_CMDNAM ${CMAKE_Fortran_COMPILER} NAME_WE)
      message(STATUS "Using Compaq Fortran compiler with command name ${CMAKE_Fortran_COMPILER_CMDNAM}")
      set(cmd ${CMAKE_Fortran_COMPILER_CMDNAM})
      string(TOLOWER "${cmd}" cmdlc)
      if(cmdlc STREQUAL "df")
        message(STATUS "Assume the Compaq Visual Fortran Compiler is being used")
        set(CMAKE_Fortran_USE_RESPONSE_FILE_FOR_OBJECTS 1)
        set(CMAKE_Fortran_USE_RESPONSE_FILE_FOR_INCLUDES 1)
        #This is a workaround that is needed to avoid forward-slashes in the
        #filenames listed in response files from incorrectly being interpreted as
        #introducing compiler command options
        if(${BUILD_SHARED_LIBS})
          message(FATAL_ERROR "Making of shared libraries with CVF has not been tested.")
        endif()
        set(str "NMake version 9 or later should be used. NMake version 6.0 which is\n")
        set(str "${str}   included with the CVF distribution fails to build Lapack because\n")
        set(str "${str}   the number of source files exceeds the limit for NMake v6.0\n")
        message(STATUS ${str})
        set(CMAKE_Fortran_LINK_EXECUTABLE "LINK /out:<TARGET> <LINK_FLAGS> <LINK_LIBRARIES> <OBJECTS>")
      endif()
    endif()
  endif()
endif()

# Disable Warings for BLAS
if ( CMAKE_Fortran_COMPILER_ID STREQUAL "GNU" )
	SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -ffloat-store -Wno-conversion -Wno-maybe-uninitialized -Wno-unused-dummy-argument -Wno-unused-variable -Wno-intrinsic-shadow -Wno-surprising -Wno-character-truncation")
endif()

IF ( INTEGER8 STREQUAL ON )
	SET (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${I8_FLAGS}")
	ADD_DEFINITIONS(-DINTEGER8)
ENDIF()



# --------------------------------------------------
# Check for any necessary platform specific compiler flags
include(CheckLAPACKCompilerFlags)
CheckLAPACKCompilerFlags()

# --------------------------------------------------
# Check second function

include(CheckTimeFunction)
set(NONE ${TIME_FUNC})
CHECK_TIME_FUNCTION(NONE TIME_FUNC)
CHECK_TIME_FUNCTION(INT_CPU_TIME TIME_FUNC)
CHECK_TIME_FUNCTION(EXT_ETIME TIME_FUNC)
CHECK_TIME_FUNCTION(EXT_ETIME_ TIME_FUNC)
CHECK_TIME_FUNCTION(INT_ETIME TIME_FUNC)
message(STATUS "--> Will use second_${TIME_FUNC}.f and dsecnd_${TIME_FUNC}.f as timing function.")

set(SECOND_SRC ${LAPACK_SOURCE_DIR}/INSTALL/second_${TIME_FUNC}.f)
set(DSECOND_SRC ${LAPACK_SOURCE_DIR}/INSTALL/dsecnd_${TIME_FUNC}.f)

add_subdirectory(SRC)

=== contributed/lapack-3.12.0/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

project(LAPACK Fortran C)

set(LAPACK_MAJOR_VERSION 3)
set(LAPACK_MINOR_VERSION 12)
set(LAPACK_PATCH_VERSION 0)
set(
  LAPACK_VERSION
  ${LAPACK_MAJOR_VERSION}.${LAPACK_MINOR_VERSION}.${LAPACK_PATCH_VERSION}
  )

# Add the CMake directory for custom CMake modules
set(CMAKE_MODULE_PATH "${LAPACK_SOURCE_DIR}/CMAKE" ${CMAKE_MODULE_PATH})

# Export all symbols on Windows when building shared libraries
SET(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo" "Coverage")
endif()

include(PreventInSourceBuilds)
include(PreventInBuildInstalls)

# Check if recursive flag exists
include(CheckFortranCompilerFlag)
if(CMAKE_Fortran_COMPILER_ID STREQUAL Flang)
  check_fortran_compiler_flag("-Mrecursive" _MrecursiveFlag)
elseif(CMAKE_Fortran_COMPILER_ID STREQUAL GNU)
  check_fortran_compiler_flag("-frecursive" _frecursiveFlag)
elseif(CMAKE_Fortran_COMPILER_ID STREQUAL Intel)
  check_fortran_compiler_flag("-recursive" _recursiveFlag)
elseif(CMAKE_Fortran_COMPILER_ID STREQUAL XL)
  check_fortran_compiler_flag("-qrecur" _qrecurFlag)
else()
  message(WARNING "Fortran local arrays should be allocated on the stack."
    " Please use a compiler which guarantees that feature."
    " See https://github.com/Reference-LAPACK/lapack/pull/188 and references therein.")
endif()

# Add recursive flag
if(_MrecursiveFlag)
  string(REGEX MATCH "-Mrecursive" output_test <string> "${CMAKE_Fortran_FLAGS}")
  if(NOT output_test)
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -Mrecursive"
      CACHE STRING "Recursive flag must be set" FORCE)
  endif()
elseif(_frecursiveFlag)
  string(REGEX MATCH "-frecursive" output_test <string> "${CMAKE_Fortran_FLAGS}")
  if(NOT output_test)
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -frecursive"
      CACHE STRING "Recursive flag must be set" FORCE)
  endif()
elseif(_recursiveFlag)
  string(REGEX MATCH "-recursive" output_test <string> "${CMAKE_Fortran_FLAGS}")
  if(NOT output_test)
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -recursive"
      CACHE STRING "Recursive flag must be set" FORCE)
  endif()
elseif(_qrecurFlag)
  string(REGEX MATCH "-qrecur" output_test <string> "${CMAKE_Fortran_FLAGS}")
  if(NOT output_test)
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -qrecur"
      CACHE STRING "Recursive flag must be set" FORCE)
  endif()
endif()

if(UNIX)
  if(CMAKE_Fortran_COMPILER_ID STREQUAL Intel)
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fp-model strict")
  endif()
  if(CMAKE_Fortran_COMPILER_ID STREQUAL XL)
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -qnosave -qstrict")
  endif()
# Delete libmtsk in linking sequence for Sun/Oracle Fortran Compiler.
# This library is not present in the Sun package SolarisStudio12.3-linux-x86-bin
  string(REPLACE \;mtsk\; \; CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES "${CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES}")
endif()

if(CMAKE_Fortran_COMPILER_ID STREQUAL Compaq)
  if(WIN32)
    if(CMAKE_GENERATOR STREQUAL "NMake Makefiles")
      get_filename_component(CMAKE_Fortran_COMPILER_CMDNAM ${CMAKE_Fortran_COMPILER} NAME_WE)
      message(STATUS "Using Compaq Fortran compiler with command name ${CMAKE_Fortran_COMPILER_CMDNAM}")
      set(cmd ${CMAKE_Fortran_COMPILER_CMDNAM})
      string(TOLOWER "${cmd}" cmdlc)
      if(cmdlc STREQUAL "df")
        message(STATUS "Assume the Compaq Visual Fortran Compiler is being used")
        set(CMAKE_Fortran_USE_RESPONSE_FILE_FOR_OBJECTS 1)
        set(CMAKE_Fortran_USE_RESPONSE_FILE_FOR_INCLUDES 1)
        #This is a workaround that is needed to avoid forward-slashes in the
        #filenames listed in response files from incorrectly being interpreted as
        #introducing compiler command options
        if(${BUILD_SHARED_LIBS})
          message(FATAL_ERROR "Making of shared libraries with CVF has not been tested.")
        endif()
        set(str "NMake version 9 or later should be used. NMake version 6.0 which is\n")
        set(str "${str}   included with the CVF distribution fails to build Lapack because\n")
        set(str "${str}   the number of source files exceeds the limit for NMake v6.0\n")
        message(STATUS ${str})
        set(CMAKE_Fortran_LINK_EXECUTABLE "LINK /out:<TARGET> <LINK_FLAGS> <LINK_LIBRARIES> <OBJECTS>")
      endif()
    endif()
  endif()
endif()

# Disable Warings for BLAS
if ( CMAKE_Fortran_COMPILER_ID STREQUAL "GNU" )
	SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -ffloat-store -Wno-conversion -Wno-maybe-uninitialized -Wno-unused-dummy-argument -Wno-unused-variable -Wno-intrinsic-shadow -Wno-surprising -Wno-character-truncation")
endif()

IF ( INTEGER8 STREQUAL ON )
	SET (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${I8_FLAGS}")
	ADD_DEFINITIONS(-DINTEGER8)
ENDIF()



# --------------------------------------------------
# Check for any necessary platform specific compiler flags
include(CheckLAPACKCompilerFlags)
CheckLAPACKCompilerFlags()

# --------------------------------------------------
# Check second function

include(CheckTimeFunction)
set(NONE ${TIME_FUNC})
CHECK_TIME_FUNCTION(NONE TIME_FUNC)
CHECK_TIME_FUNCTION(INT_CPU_TIME TIME_FUNC)
CHECK_TIME_FUNCTION(EXT_ETIME TIME_FUNC)
CHECK_TIME_FUNCTION(EXT_ETIME_ TIME_FUNC)
CHECK_TIME_FUNCTION(INT_ETIME TIME_FUNC)
message(STATUS "--> Will use second_${TIME_FUNC}.f and dsecnd_${TIME_FUNC}.f as timing function.")

set(SECOND_SRC ${LAPACK_SOURCE_DIR}/INSTALL/second_${TIME_FUNC}.f)
set(DSECOND_SRC ${LAPACK_SOURCE_DIR}/INSTALL/dsecnd_${TIME_FUNC}.f)

add_subdirectory(SRC)

=== contributed/lapack-3.6.1/CMakeLists.txt ===
CheckPolicy(CMP0048 NEW)
cmake_minimum_required(VERSION 3.5)
project(LAPACK Fortran)

set(LAPACK_MAJOR_VERSION 3)
set(LAPACK_MINOR_VERSION 6)
set(LAPACK_PATCH_VERSION 1)
set(
  LAPACK_VERSION
  ${LAPACK_MAJOR_VERSION}.${LAPACK_MINOR_VERSION}.${LAPACK_PATCH_VERSION}
  )

# Add the CMake directory for custon CMake modules
set(CMAKE_MODULE_PATH "${LAPACK_SOURCE_DIR}/CMAKE" ${CMAKE_MODULE_PATH})

if (UNIX)
   if ( "${CMAKE_Fortran_COMPILER}" MATCHES "ifort" )
  set( CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fp-model strict" )
   endif ()
   if ( "${CMAKE_Fortran_COMPILER}" MATCHES "xlf" )
  set( CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -qnosave -qstrict=none" )
   endif ()
# Delete libmtsk in linking sequence for Sun/Oracle Fortran Compiler.
# This library is not present in the Sun package SolarisStudio12.3-linux-x86-bin
   STRING(REPLACE \;mtsk\; \; CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES "${CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES}")
endif ()


# Disable Warings for BLAS
if ( CMAKE_Fortran_COMPILER_ID STREQUAL "GNU" )
	SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -Wno-conversion -Wno-maybe-uninitialized -Wno-unused-dummy-argument -Wno-unused-variable -Wno-intrinsic-shadow -Wno-surprising -Wno-character-truncation")
endif()

# --------------------------------------------------
# Check for any necessary platform specific compiler flags
include( CheckLAPACKCompilerFlags )
CheckLAPACKCompilerFlags()

# --------------------------------------------------
# Check second function

include(CheckTimeFunction)
set(TIME_FUNC NONE ${TIME_FUNC})
CHECK_TIME_FUNCTION(NONE TIME_FUNC)
CHECK_TIME_FUNCTION(INT_CPU_TIME TIME_FUNC)
CHECK_TIME_FUNCTION(EXT_ETIME TIME_FUNC)
CHECK_TIME_FUNCTION(EXT_ETIME_ TIME_FUNC)
CHECK_TIME_FUNCTION(INT_ETIME TIME_FUNC)
message(STATUS "--> Will use second_${TIME_FUNC}.f and dsecnd_${TIME_FUNC}.f as timing function.")

set(SECOND_SRC  ${LAPACK_SOURCE_DIR}/INSTALL/second_${TIME_FUNC}.f)
set(DSECOND_SRC  ${LAPACK_SOURCE_DIR}/INSTALL/dsecnd_${TIME_FUNC}.f)

IF ( INTEGER8 STREQUAL ON )
	SET (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${I8_FLAGS}")
	ADD_DEFINITIONS(-DINTEGER8)
ENDIF()

# --------------------------------------------------
# Precision to build
# By default all precisions are generated
option(BUILD_DEPRECATED "Build deprecated routines" ON)
add_subdirectory(SRC)

=== contributed/lapack-3.7.0/CMakeLists.txt ===
CheckPolicy(CMP0048 NEW)
cmake_minimum_required(VERSION 3.5)
project(LAPACK Fortran)

set(LAPACK_MAJOR_VERSION 3)
set(LAPACK_MINOR_VERSION 7)
set(LAPACK_PATCH_VERSION 0)
set(
  LAPACK_VERSION
  ${LAPACK_MAJOR_VERSION}.${LAPACK_MINOR_VERSION}.${LAPACK_PATCH_VERSION}
  )

# Add the CMake directory for custon CMake modules
set(CMAKE_MODULE_PATH "${LAPACK_SOURCE_DIR}/CMAKE" ${CMAKE_MODULE_PATH})

if (UNIX)
   if ( "${CMAKE_Fortran_COMPILER}" MATCHES "ifort" )
  set( CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fp-model strict" )
   endif ()
   if ( "${CMAKE_Fortran_COMPILER}" MATCHES "xlf" )
  set( CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -qnosave -qstrict=none" )
   endif ()
# Delete libmtsk in linking sequence for Sun/Oracle Fortran Compiler.
# This library is not present in the Sun package SolarisStudio12.3-linux-x86-bin
   STRING(REPLACE \;mtsk\; \; CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES "${CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES}")
endif ()
STRING(REPLACE \;mtsk\; \; CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES "${CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES}")



# Disable Warings for BLAS
if ( CMAKE_Fortran_COMPILER_ID STREQUAL "GNU" )
	SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -Wno-conversion -Wno-maybe-uninitialized -Wno-unused-dummy-argument -Wno-unused-variable -Wno-intrinsic-shadow -Wno-surprising -Wno-character-truncation")
endif()
# --------------------------------------------------
# Check for any necessary platform specific compiler flags
include( CheckLAPACKCompilerFlags )
CheckLAPACKCompilerFlags()

# --------------------------------------------------
# Check second function

include(CheckTimeFunction)
set(TIME_FUNC NONE ${TIME_FUNC})
CHECK_TIME_FUNCTION(NONE TIME_FUNC)
CHECK_TIME_FUNCTION(INT_CPU_TIME TIME_FUNC)
CHECK_TIME_FUNCTION(EXT_ETIME TIME_FUNC)
CHECK_TIME_FUNCTION(EXT_ETIME_ TIME_FUNC)
CHECK_TIME_FUNCTION(INT_ETIME TIME_FUNC)
message(STATUS "--> Will use second_${TIME_FUNC}.f and dsecnd_${TIME_FUNC}.f as timing function.")

set(SECOND_SRC  ${LAPACK_SOURCE_DIR}/INSTALL/second_${TIME_FUNC}.f)
set(DSECOND_SRC  ${LAPACK_SOURCE_DIR}/INSTALL/dsecnd_${TIME_FUNC}.f)

IF ( INTEGER8 STREQUAL ON )
	SET (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${I8_FLAGS}")
	ADD_DEFINITIONS(-DINTEGER8)
ENDIF()

# --------------------------------------------------
# Precision to build
# By default all precisions are generated
add_subdirectory(SRC)

=== contributed/lapack-3.8.0/CMakeLists.txt ===
CheckPolicy(CMP0048 NEW)
cmake_minimum_required(VERSION 3.5)

project(LAPACK Fortran C)

set(LAPACK_MAJOR_VERSION 3)
set(LAPACK_MINOR_VERSION 8)
set(LAPACK_PATCH_VERSION 0)
set(
  LAPACK_VERSION
  ${LAPACK_MAJOR_VERSION}.${LAPACK_MINOR_VERSION}.${LAPACK_PATCH_VERSION}
  )

# Add the CMake directory for custon CMake modules
set(CMAKE_MODULE_PATH "${LAPACK_SOURCE_DIR}/CMAKE" ${CMAKE_MODULE_PATH})

if(UNIX)
  if("${CMAKE_Fortran_COMPILER}" MATCHES "ifort")
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fp-model strict")
  endif()
  if("${CMAKE_Fortran_COMPILER}" MATCHES "xlf")
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -qnosave -qstrict=none")
  endif()
# Delete libmtsk in linking sequence for Sun/Oracle Fortran Compiler.
# This library is not present in the Sun package SolarisStudio12.3-linux-x86-bin
  string(REPLACE \;mtsk\; \; CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES "${CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES}")
endif()

if(CMAKE_Fortran_COMPILER_ID STREQUAL "Compaq")
  if(WIN32)
    if(CMAKE_GENERATOR STREQUAL "NMake Makefiles")
      get_filename_component(CMAKE_Fortran_COMPILER_CMDNAM ${CMAKE_Fortran_COMPILER} NAME_WE)
      message(STATUS "Using Compaq Fortran compiler with command name ${CMAKE_Fortran_COMPILER_CMDNAM}")
      set(cmd ${CMAKE_Fortran_COMPILER_CMDNAM})
      string(TOLOWER "${cmd}" cmdlc)
      if(cmdlc STREQUAL "df")
        message(STATUS "Assume the Compaq Visual Fortran Compiler is being used")
        set(CMAKE_Fortran_USE_RESPONSE_FILE_FOR_OBJECTS 1)
        set(CMAKE_Fortran_USE_RESPONSE_FILE_FOR_INCLUDES 1)
        #This is a workaround that is needed to avoid forward-slashes in the
        #filenames listed in response files from incorrectly being interpreted as
        #introducing compiler command options
        if(${BUILD_SHARED_LIBS})
          message(FATAL_ERROR "Making of shared libraries with CVF has not been tested.")
        endif()
        set(str "NMake version 9 or later should be used. NMake version 6.0 which is\n")
        set(str "${str}   included with the CVF distribution fails to build Lapack because\n")
        set(str "${str}   the number of source files exceeds the limit for NMake v6.0\n")
        message(STATUS ${str})
        set(CMAKE_Fortran_LINK_EXECUTABLE "LINK /out:<TARGET> <LINK_FLAGS> <LINK_LIBRARIES> <OBJECTS>")
      endif()
    endif()
  endif()
endif()

# Disable Warings for BLAS
if ( CMAKE_Fortran_COMPILER_ID STREQUAL "GNU" )
	SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -ffloat-store -Wno-conversion -Wno-maybe-uninitialized -Wno-unused-dummy-argument -Wno-unused-variable -Wno-intrinsic-shadow -Wno-surprising -Wno-character-truncation")
endif()

# --------------------------------------------------
# Check for any necessary platform specific compiler flags
include(CheckLAPACKCompilerFlags)
CheckLAPACKCompilerFlags()

IF ( INTEGER8 STREQUAL ON )
	SET (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${I8_FLAGS}")
	ADD_DEFINITIONS(-DINTEGER8)
ENDIF()

# --------------------------------------------------
# Check second function

include(CheckTimeFunction)
set(TIME_FUNC NONE ${TIME_FUNC})
CHECK_TIME_FUNCTION(NONE TIME_FUNC)
CHECK_TIME_FUNCTION(INT_CPU_TIME TIME_FUNC)
CHECK_TIME_FUNCTION(EXT_ETIME TIME_FUNC)
CHECK_TIME_FUNCTION(EXT_ETIME_ TIME_FUNC)
CHECK_TIME_FUNCTION(INT_ETIME TIME_FUNC)
message(STATUS "--> Will use second_${TIME_FUNC}.f and dsecnd_${TIME_FUNC}.f as timing function.")

set(SECOND_SRC ${LAPACK_SOURCE_DIR}/INSTALL/second_${TIME_FUNC}.f)
set(DSECOND_SRC ${LAPACK_SOURCE_DIR}/INSTALL/dsecnd_${TIME_FUNC}.f)

add_subdirectory(SRC)

=== contributed/lapack-3.9.0/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
CheckPolicy(CMP0048 NEW)
project(LAPACK Fortran C)

set(LAPACK_MAJOR_VERSION 3)
set(LAPACK_MINOR_VERSION 9)
set(LAPACK_PATCH_VERSION 0)
set(
  LAPACK_VERSION
  ${LAPACK_MAJOR_VERSION}.${LAPACK_MINOR_VERSION}.${LAPACK_PATCH_VERSION}
  )

# Add the CMake directory for custon CMake modules
set(CMAKE_MODULE_PATH "${LAPACK_SOURCE_DIR}/CMAKE" ${CMAKE_MODULE_PATH})

if(UNIX)
  if("${CMAKE_Fortran_COMPILER}" MATCHES "ifort")
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fp-model strict")
  endif()
  if("${CMAKE_Fortran_COMPILER}" MATCHES "xlf")
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -qnosave -qstrict=none")
  endif()
# Delete libmtsk in linking sequence for Sun/Oracle Fortran Compiler.
# This library is not present in the Sun package SolarisStudio12.3-linux-x86-bin
  string(REPLACE \;mtsk\; \; CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES "${CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES}")
endif()

if(CMAKE_Fortran_COMPILER_ID STREQUAL "Compaq")
  if(WIN32)
    if(CMAKE_GENERATOR STREQUAL "NMake Makefiles")
      get_filename_component(CMAKE_Fortran_COMPILER_CMDNAM ${CMAKE_Fortran_COMPILER} NAME_WE)
      message(STATUS "Using Compaq Fortran compiler with command name ${CMAKE_Fortran_COMPILER_CMDNAM}")
      set(cmd ${CMAKE_Fortran_COMPILER_CMDNAM})
      string(TOLOWER "${cmd}" cmdlc)
      if(cmdlc STREQUAL "df")
        message(STATUS "Assume the Compaq Visual Fortran Compiler is being used")
        set(CMAKE_Fortran_USE_RESPONSE_FILE_FOR_OBJECTS 1)
        set(CMAKE_Fortran_USE_RESPONSE_FILE_FOR_INCLUDES 1)
        #This is a workaround that is needed to avoid forward-slashes in the
        #filenames listed in response files from incorrectly being interpreted as
        #introducing compiler command options
        if(${BUILD_SHARED_LIBS})
          message(FATAL_ERROR "Making of shared libraries with CVF has not been tested.")
        endif()
        set(str "NMake version 9 or later should be used. NMake version 6.0 which is\n")
        set(str "${str}   included with the CVF distribution fails to build Lapack because\n")
        set(str "${str}   the number of source files exceeds the limit for NMake v6.0\n")
        message(STATUS ${str})
        set(CMAKE_Fortran_LINK_EXECUTABLE "LINK /out:<TARGET> <LINK_FLAGS> <LINK_LIBRARIES> <OBJECTS>")
      endif()
    endif()
  endif()
endif()

# Disable Warings for BLAS
if ( CMAKE_Fortran_COMPILER_ID STREQUAL "GNU" )
	SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -ffloat-store -Wno-conversion -Wno-maybe-uninitialized -Wno-unused-dummy-argument -Wno-unused-variable -Wno-intrinsic-shadow -Wno-surprising -Wno-character-truncation")
endif()

# --------------------------------------------------
# Check for any necessary platform specific compiler flags
include(CheckLAPACKCompilerFlags)
CheckLAPACKCompilerFlags()

IF ( INTEGER8 STREQUAL ON )
	SET (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${I8_FLAGS}")
	ADD_DEFINITIONS(-DINTEGER8)
ENDIF()

# --------------------------------------------------
# Check second function

include(CheckTimeFunction)
set(TIME_FUNC NONE ${TIME_FUNC})
CHECK_TIME_FUNCTION(NONE TIME_FUNC)
CHECK_TIME_FUNCTION(INT_CPU_TIME TIME_FUNC)
CHECK_TIME_FUNCTION(EXT_ETIME TIME_FUNC)
CHECK_TIME_FUNCTION(EXT_ETIME_ TIME_FUNC)
CHECK_TIME_FUNCTION(INT_ETIME TIME_FUNC)
message(STATUS "--> Will use second_${TIME_FUNC}.f and dsecnd_${TIME_FUNC}.f as timing function.")

set(SECOND_SRC ${LAPACK_SOURCE_DIR}/INSTALL/second_${TIME_FUNC}.f)
set(DSECOND_SRC ${LAPACK_SOURCE_DIR}/INSTALL/dsecnd_${TIME_FUNC}.f)

add_subdirectory(SRC)

=== contributed/lapack-3.9.1/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
CheckPolicy(CMP0048 NEW)
project(LAPACK Fortran C)

set(LAPACK_MAJOR_VERSION 3)
set(LAPACK_MINOR_VERSION 9)
set(LAPACK_PATCH_VERSION 1)
set(
  LAPACK_VERSION
  ${LAPACK_MAJOR_VERSION}.${LAPACK_MINOR_VERSION}.${LAPACK_PATCH_VERSION}
  )

# Add the CMake directory for custon CMake modules
set(CMAKE_MODULE_PATH "${LAPACK_SOURCE_DIR}/CMAKE" ${CMAKE_MODULE_PATH})

if(UNIX)
  if("${CMAKE_Fortran_COMPILER}" MATCHES "ifort")
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fp-model strict")
  endif()
  if("${CMAKE_Fortran_COMPILER}" MATCHES "xlf")
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -qnosave -qstrict=none")
  endif()
# Delete libmtsk in linking sequence for Sun/Oracle Fortran Compiler.
# This library is not present in the Sun package SolarisStudio12.3-linux-x86-bin
  string(REPLACE \;mtsk\; \; CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES "${CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES}")
endif()

if(CMAKE_Fortran_COMPILER_ID STREQUAL "Compaq")
  if(WIN32)
    if(CMAKE_GENERATOR STREQUAL "NMake Makefiles")
      get_filename_component(CMAKE_Fortran_COMPILER_CMDNAM ${CMAKE_Fortran_COMPILER} NAME_WE)
      message(STATUS "Using Compaq Fortran compiler with command name ${CMAKE_Fortran_COMPILER_CMDNAM}")
      set(cmd ${CMAKE_Fortran_COMPILER_CMDNAM})
      string(TOLOWER "${cmd}" cmdlc)
      if(cmdlc STREQUAL "df")
        message(STATUS "Assume the Compaq Visual Fortran Compiler is being used")
        set(CMAKE_Fortran_USE_RESPONSE_FILE_FOR_OBJECTS 1)
        set(CMAKE_Fortran_USE_RESPONSE_FILE_FOR_INCLUDES 1)
        #This is a workaround that is needed to avoid forward-slashes in the
        #filenames listed in response files from incorrectly being interpreted as
        #introducing compiler command options
        if(${BUILD_SHARED_LIBS})
          message(FATAL_ERROR "Making of shared libraries with CVF has not been tested.")
        endif()
        set(str "NMake version 9 or later should be used. NMake version 6.0 which is\n")
        set(str "${str}   included with the CVF distribution fails to build Lapack because\n")
        set(str "${str}   the number of source files exceeds the limit for NMake v6.0\n")
        message(STATUS ${str})
        set(CMAKE_Fortran_LINK_EXECUTABLE "LINK /out:<TARGET> <LINK_FLAGS> <LINK_LIBRARIES> <OBJECTS>")
      endif()
    endif()
  endif()
endif()

# Disable Warings for BLAS
if ( CMAKE_Fortran_COMPILER_ID STREQUAL "GNU" )
	SET(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -ffloat-store -Wno-conversion -Wno-maybe-uninitialized -Wno-unused-dummy-argument -Wno-unused-variable -Wno-intrinsic-shadow -Wno-surprising -Wno-character-truncation")
endif()

# --------------------------------------------------
# Check for any necessary platform specific compiler flags
include(CheckLAPACKCompilerFlags)
CheckLAPACKCompilerFlags()

IF ( INTEGER8 STREQUAL ON )
	SET (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${I8_FLAGS}")
	ADD_DEFINITIONS(-DINTEGER8)
ENDIF()

# --------------------------------------------------
# Check second function

include(CheckTimeFunction)
set(TIME_FUNC NONE ${TIME_FUNC})
CHECK_TIME_FUNCTION(NONE TIME_FUNC)
CHECK_TIME_FUNCTION(INT_CPU_TIME TIME_FUNC)
CHECK_TIME_FUNCTION(EXT_ETIME TIME_FUNC)
CHECK_TIME_FUNCTION(EXT_ETIME_ TIME_FUNC)
CHECK_TIME_FUNCTION(INT_ETIME TIME_FUNC)
message(STATUS "--> Will use second_${TIME_FUNC}.f and dsecnd_${TIME_FUNC}.f as timing function.")

set(SECOND_SRC ${LAPACK_SOURCE_DIR}/INSTALL/second_${TIME_FUNC}.f)
set(DSECOND_SRC ${LAPACK_SOURCE_DIR}/INSTALL/dsecnd_${TIME_FUNC}.f)

add_subdirectory(SRC)

=== debian/changelog ===
flexiblas (3.4.1) UNRELEASED; urgency=medium

  * New patch release. See CHANGELOG

 -- Martin Koehler <koehlerm@mpi-magdeburg.mpg.de>  Wed, 10 Jan 2024 15:06:20 +0100

flexiblas (3.4.0) focal; urgency=medium

  * New minor release. See CHANGELOG

 -- Martin Koehler <koehlerm@mpi-magdeburg.mpg.de>  Tue, 09 Jan 2024 13:21:12 +0100

flexiblas (3.3.0) focal; urgency=medium

  * New minor release. See CHANGELOG

 -- Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Mon, 19 Dec 2022 20:52:04 +0100

flexiblas (3.2.1) focal; urgency=medium

  * Bugfix release. See CHANGELOG

 -- Martin Koehler <koehlerm@mpi-magdeburg.mpg.de>  Tue, 12 Jul 2022 12:00:00 +0100

flexiblas (3.2.0) focal; urgency=medium

  * New minor release. See CHANGELOG

 -- Martin Koehler <koehlerm@mpi-magdeburg.mpg.de>  Thu, 17 May 2022 12:00:00 +0100

flexiblas (3.1.3) focal; urgency=medium

  * Bugfix release for 3.1.0

 -- Martin Koehler <koehlerm@mpi-magdeburg.mpg.de>  Fri, 22 Jan 2022 20:00:00 +0100

flexiblas (3.1.2) focal; urgency=medium

  * Bugfix release for 3.1.0

 -- Martin Koehler <koehlerm@mpi-magdeburg.mpg.de>  Mon, 17 Jan 2022 20:00:00 +0100

flexiblas (3.1.1) focal; urgency=medium

  * Bugfix release for 3.1.0

 -- Martin Koehler <koehlerm@mpi-magdeburg.mpg.de>  Mon, 17 Jan 2022 12:00:00 +0100

flexiblas (3.1.0) focal; urgency=medium

  * See CHANGELOG

 -- Martin Koehler <koehlerm@mpi-magdeburg.mpg.de>  Sun, 16 Jan 2022 12:00:00 +0100

flexiblas (3.0.4) focal; urgency=medium

  * Closes #107: DCABS1 and SCABS1 missing
  * Closes #105: Could not compile on FreeBSD
  * Closes #104: Missing prefix in some outputs of xerbla.c
  * Closes #103: GH #7 - LAPACK decompositions do not run in parallel
  * Closes #102: GH #6 - Wrong return type.

 -- Martin Koehler <koehlerm@mpi-magdeburg.mpg.de>  Thu, 22 Oct 2020 10:52:54 +0200

flexiblas (3.0.3) focal; urgency=medium

  * Close #101: DLAMC3 and SLAMC3 missing

 -- Martin Koehler <koehlerm@mpi-magdeburg.mpg.de>  Fri, 28 Aug 2020 14:35:54 +0200

flexiblas (3.0.2) focal; urgency=medium

  * Close #99, #100: Include codegens in source

 -- Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Thu, 23 Jul 2020 09:58:03 +0200

flexiblas (3.0.1) focal; urgency=medium

  * Close #97: Hooks are loaded up to LAPACK 3.9.0
  * Close #92: CBLAS works with 64bit integer values on big-endian
  * Close #94: LSAMEN with implicit casting returns wrong values on big-endian
             systems.
  * Close #95: Failed looking up symbols from hooks when used from Python
  * Close #91: Manpages still reference GPLv2+


 -- Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Wed, 01 Jul 2020 09:05:35 +0200

flexiblas (3.0.0) focal; urgency=medium

  * Rewrite of the hook System
  * 32 and 64 bit integer builds can coexist
  * detection of the BLIS library


 -- Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Wed, 01 Jul 2020 09:05:23 +0200

flexiblas (2.0.0) unstable; urgency=medium

  * Fixed: Bug/Crash if default backend does not exist
  * New Benchmark Tool (AXPY,GEMM,GEMV unified, latency tests)
  * Rewrite the FlexiBLAS tool to use a common management library.
  * Include LAPACK Interface (Maximum API Level 3.7.0)
  * Update CBLAS tests to current versions
  * Many fixes and code rewrites

 -- Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Fri, 26 Feb 2016 16:31:56 +0100

flexiblas (1.3.0) unstable; urgency=low

  * Add s/d/c/z geadd function from ATLAS/OpenBLAS
  * Allow to overload BLAS functions using hooks.
  * Runtime switching of BLAS libraries.
  * Profiling information in now held in the structure of the correponding BLAS
    functions, but accumulated in the end.
  * Configuration is done using libcscutils/ini, i.e., we have an ini-file like
    configuration system.
  * flexiblas command line tool redesigned.
  * BLAS routines can be replaced in the backends. See
    src/backends/demo/backend.c for details.
  * The wrapper are generated via code generation software.
  * Different integer sizes are supported. Each routine comes with a default
    integer variant (which is either 32 or 64 bit selected at compile time.) and
    additionally a 32 and 64 bit interface. (experimental, please do not use in
    production code)
  * Code cleanup
  * Octave Interface

 -- Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Wed, 04 Nov 2015 15:00:00 +0200

flexiblas (1.2.0) unstable; urgency=low

  * add s/d/c/z axpby as BLAS extension (Like in OpenBLAS or MKL)
  * add s/d/c/z omatcopy as BLAS extension, following both APIs (OpenBLAS and MKL)
  * add s/d/c/z imatcopy as BLAS extension, following both APIs (OpenBLAS and MKL)
    new configure option: -DDEV=ON/OFF  to enable development builds the run only
  * in the build directory. Default is OFF.
  * user supplied XERBLA functions now work with ACML and MKL
  * add CBLAS tests
  * working 8-byte integer support

 -- Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Thu, 06 Nov 2014 15:00:00 +0200

flexiblas (1.1.1) unstable; urgency=low

  * fix DSCABS1

 -- Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Thu, 04 Sep 2014 15:00:00 +0200

flexiblas (1.1.0) unstable; urgency=low

  * Combine flexiblas and fleixblas-profile
  * internal rewriting
  * support additional search paths in the config files


 -- Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Thu, 04 Sep 2014 15:00:00 +0200

flexiblas (1.0.1) unstable; urgency=low

  * Fixed SCABS1

 --  Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Wed, 30 Apr  2014 11:15:00 +0100

flexiblas (1.0.0) unstable; urgency=low

  * Lift version to 1.0.0

 --  Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Wed, 08 Jan 2014 10:36:45 +0100

flexiblas (0.1.0) unstable; urgency=low

  * Initial Release.

 -- Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>  Wed, 11 Sep 2013 08:37:42 +0200

=== debian/control ===
Source: flexiblas
Priority: optional
Maintainer: Martin Köhler <koehlerm@mpi-magdeburg.mpg.de>
Build-Depends: debhelper (>= 11.0.0), cmake, gfortran (>= 5.1.0), gcc (>= 5.1.0), libatlas-base-dev (>= 3.8.0),
 libopenblas-openmp-dev, libopenblas-pthread-dev, libopenblas-serial-dev,
 libopenblas64-openmp-dev, libopenblas64-pthread-dev, libopenblas64-serial-dev,
 libblis-openmp-dev, libblis-pthread-dev, libblis-serial-dev,
 libblis64-openmp-dev, libblis64-pthread-dev, libblis64-serial-dev,
 libblas-dev, libblas64-dev, liblapack-dev, liblapack64-dev, libmkl-dev [amd64]
Standards-Version: 4.5.0
Section: libs
Homepage: http://www.mpi-magdeburg.mpg.de/projects/flexiblas

Package: libflexiblas
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Flexible and Exchangeable BLAS library.
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 You can select the BLAS implementation which is used behind
 FlexiBLAS using a configuration file or a environment variable.
 It is integrated in Debian/Ubuntu using the update-alternatives
 mechanism.
 .
 The package supports OpenBLAS, ATLAS and the reference Netlib
 implementation. If you compile FlexiBLAS on your own, other
 BLAS implementations like the old GotoBLAS or the Intel MKL
 are supported.
 .
 This package contains the runtime part of FlexiBLAS.

Package: libflexiblas64
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Flexible and Exchangeable BLAS library (64bit integers).
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 You can select the BLAS implementation which is used behind
 FlexiBLAS using a configuration file or a environment variable.
 It is integrated in Debian/Ubuntu using the update-alternatives
 mechanism.
 .
 The package supports OpenBLAS, ATLAS and the reference Netlib
 implementation. If you compile FlexiBLAS on your own, other
 BLAS implementations like the old GotoBLAS or the Intel MKL
 are supported.
 .
 This package contains the runtime part of FlexiBLAS. It contains
 the 64 bit integer library of FlexiBLAS.

Package: libflexiblas-bin
Section: admin
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Flexible and Exchangeable BLAS library. Management Tool.
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 You can select the BLAS implementation which is used behind
 FlexiBLAS using a configuration file or a environment variable.
 It is integrated in Debian/Ubuntu using the update-alternatives
 mechanism.
 .
 The package supports OpenBLAS, ATLAS and the reference Netlib
 implementation. If you compile FlexiBLAS on your own, other
 BLAS implementations like the old GotoBLAS or the Intel MKL
 are supported.
 .
 This package contains the management tool for the FlexiBLAS
 library.

Package: libflexiblas64-bin
Section: admin
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Flexible and Exchangeable BLAS library. Management Tool. (64bit integers).
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 You can select the BLAS implementation which is used behind
 FlexiBLAS using a configuration file or a environment variable.
 It is integrated in Debian/Ubuntu using the update-alternatives
 mechanism.
 .
 The package supports OpenBLAS, ATLAS and the reference Netlib
 implementation. If you compile FlexiBLAS on your own, other
 BLAS implementations like the old GotoBLAS or the Intel MKL
 are supported.
 .
 This package contains the management tool for the 64 bit integer
 version of FlexiBLAS.


Package: libflexiblas-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libflexiblas (= ${binary:Version}), libblas-dev, liblapack-dev, ${misc:Depends}
Description: Development files for libflexiblas.
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 You can select the BLAS implementation which is used behind
 FlexiBLAS using a configuration file or a environment variable.
 It is integrated in Debian/Ubuntu using the update-alternatives
 mechanism.
 .
 The package supports OpenBLAS, ATLAS and the reference Netlib
 implementation. If you compile FlexiBLAS on your own, other
 BLAS implementations like the old GotoBLAS or the Intel MKL
 are supported.
 .
 This package contains the development files.

Package: libflexiblas64-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libflexiblas64 (= ${binary:Version}), libblas64-dev, liblapack64-dev, ${misc:Depends}
Description: Development files for libflexiblas64.
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 You can select the BLAS implementation which is used behind
 FlexiBLAS using a configuration file or a environment variable.
 It is integrated in Debian/Ubuntu using the update-alternatives
 mechanism.
 .
 The package supports OpenBLAS, ATLAS and the reference Netlib
 implementation. If you compile FlexiBLAS on your own, other
 BLAS implementations like the old GotoBLAS or the Intel MKL
 are supported.
 .
 This package contains the development files for the 64 bit
 integer build.

Package: libflexiblas-api
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Flexible and Exchangeable BLAS library. Standalone API
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 You can select the BLAS implementation which is used behind
 FlexiBLAS using a configuration file or a environment variable.
 It is integrated in Debian/Ubuntu using the update-alternatives
 mechanism.
 .
 The package supports OpenBLAS, ATLAS and the reference Netlib
 implementation. If you compile FlexiBLAS on your own, other
 BLAS implementations like the old GotoBLAS or the Intel MKL
 are supported.
 .
 This package contains the standalone API of FlexiBLAS.

Package: libflexiblas64-api
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Flexible and Exchangeable BLAS library. Standalone API (64bit integers).
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 You can select the BLAS implementation which is used behind
 FlexiBLAS using a configuration file or a environment variable.
 It is integrated in Debian/Ubuntu using the update-alternatives
 mechanism.
 .
 The package supports OpenBLAS, ATLAS and the reference Netlib
 implementation. If you compile FlexiBLAS on your own, other
 BLAS implementations like the old GotoBLAS or the Intel MKL
 are supported.
 .
 This package contains the standalone API of FlexiBLAS with 64bit
 integers.


Package: libflexiblas-api-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libflexiblas-api (= ${binary:Version}), ${misc:Depends}
Description: Flexible and Exchangeable BLAS library. Standalone API. Development Files.
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 You can select the BLAS implementation which is used behind
 FlexiBLAS using a configuration file or a environment variable.
 It is integrated in Debian/Ubuntu using the update-alternatives
 mechanism.
 .
 The package supports OpenBLAS, ATLAS and the reference Netlib
 implementation. If you compile FlexiBLAS on your own, other
 BLAS implementations like the old GotoBLAS or the Intel MKL
 are supported.
 .
 This package contains the development files for the
 standalone API of FlexiBLAS.

Package: libflexiblas64-api-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libflexiblas64-api (= ${binary:Version}), libflexiblas-api-dev (= ${binary:Version}), ${misc:Depends}
Description: Flexible and Exchangeable BLAS library. Standalone API. Development Files.
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 You can select the BLAS implementation which is used behind
 FlexiBLAS using a configuration file or a environment variable.
 It is integrated in Debian/Ubuntu using the update-alternatives
 mechanism.
 .
 The package supports OpenBLAS, ATLAS and the reference Netlib
 implementation. If you compile FlexiBLAS on your own, other
 BLAS implementations like the old GotoBLAS or the Intel MKL
 are supported.
 .
 This package contains the development files of the
 standalone API of FlexiBLAS with 64 bit integers.

Package: libflexiblas-hook-profile
Section: libs
Architecture: any
Multi-Arch: same
Depends:  libflexiblas (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Profile Addion for FlexiBLAS
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 The profile hook allows easy profiling of BLAS and LAPACK
 related function calls.

Package: libflexiblas64-hook-profile
Section: libs
Architecture: any
Multi-Arch: same
Depends:  libflexiblas (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Profile Addion for FlexiBLAS (64 bit integer)
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 The profile hook allows easy profiling of BLAS and LAPACK
 related function calls.

Package: libflexiblas-atlas
Section: libs
Architecture: any
Multi-Arch: same
Depends: libflexiblas (= ${binary:Version}), libatlas3-base, ${misc:Depends}
Description: ATLAS backend for FlexiBLAS
 The FlexiBLAS library is a flexible BLAS wrapper
 which allows one to exchange the system wide BLAS
 implementation without recompiling or relinking programs.
 Even dealing with runtime-loader specific tricks is
 not necessary with FlexiBLAS.
 .
 This package contains the ATLAS backend for FlexiBLAS.

Package: libflexiblas-openblas-serial
Section: libs
Architecture: any
Multi-Arch: same
Depends: libflexiblas (= ${binary:Version}), libopenblas0-serial, ${misc:Depends}
Description: OpenBLAS Serial backend for FlexiBLAS
